#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_exportera.py

# Senast ändrad: 2011-03-02  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTextEdit, sijComboBox
############################################################################




######################################################################################
class gui_Exportera(object):

    SenastÄndrad = '2011-03-01 14:23:41'  # Uppdateras automatiskt. Ändra inte manuellt.

######################################################################################
    def setupUi(self, Exportera):

# Gränsytans statiska definitioner

        Exportera.setObjectName("Exportera")
        Exportera.setWindowTitle("Databasexport")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))

        self.mainwidget = QtGui.QWidget()
        self.setCentralWidget(self.mainwidget)
        self.mainwidget.setObjectName("mainwidget")
        self.mainwidget.setFocusPolicy(Qt.NoFocus)
        self.mainwidget.setAutoFillBackground(True)




        self.top_widget = QtGui.QWidget(self.mainwidget)
        self.Utdragsval_widget =  QtGui.QWidget(self.mainwidget)
        self.NyRad_widget = QtGui.QWidget(self.mainwidget)
        self.left_widget = QtGui.QWidget(self.mainwidget)





        self.label_Databas = QtGui.QLabel(self.top_widget)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Från databas")

        self.lineEdit_Databas = sijLineEdit(self.top_widget)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.top_widget)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText("Välj Databas")

        self.label_Nydatabas = QtGui.QLabel(self.top_widget)
        self.label_Nydatabas.setObjectName("label_Nydatabas")
        self.label_Nydatabas.setText("Till ny databas")

        self.lineEdit_Nydatabas = sijLineEdit(self.top_widget)
        self.lineEdit_Nydatabas.setObjectName("lineEdit_Nydatabas")

        self.pushButton_Nydatabas = QtGui.QPushButton(self.top_widget)
        self.pushButton_Nydatabas.setObjectName("pushButton_Nydatabas")
        self.pushButton_Nydatabas.setText("Välj Ny Databas")
        self.pushButton_Nydatabas.setVisible(False)





        self.label_Resultatformat = QtGui.QLabel(self.Utdragsval_widget)
        self.label_Resultatformat.setObjectName("Resultatformat")
        self.label_Resultatformat.setText("Resultatformat: ")

        self.label_Johanformat = QtGui.QLabel(self.Utdragsval_widget)
        self.label_Johanformat.setObjectName("Johanformat")
        self.label_Johanformat.setText(" Johan ")

        self.label_Gedcomformat = QtGui.QLabel(self.Utdragsval_widget)
        self.label_Gedcomformat.setObjectName("Gedcomformat")
        self.label_Gedcomformat.setText(" Gedcom ")


        self.radioButton_HelaDatabasen = QtGui.QRadioButton(self.Utdragsval_widget)
        self.radioButton_HelaDatabasen.setChecked(False)
        self.radioButton_HelaDatabasen.setObjectName("radioButton_HelaDatabasen")
        self.radioButton_HelaDatabasen.setText("Hela databasen")

        self.checkBox_HelaDatabasen_Johan = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_HelaDatabasen_Johan.setChecked(False)
        self.checkBox_HelaDatabasen_Johan.setObjectName("checkBox_HelaDatabasen_Johan")
        self.checkBox_HelaDatabasen_Johan.setEnabled(False)

        self.checkBox_HelaDatabasen_Gedcom = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_HelaDatabasen_Gedcom.setChecked(True)
        self.checkBox_HelaDatabasen_Gedcom.setObjectName("checkBox_HelaDatabasen_Gedcom")
        self.checkBox_HelaDatabasen_Gedcom.setEnabled(False)


        self.radioButton_ExportDisbytutdrag = QtGui.QRadioButton(self.Utdragsval_widget)
        self.radioButton_ExportDisbytutdrag.setChecked(True)
        self.radioButton_ExportDisbytutdrag.setObjectName("radioButton_ExportDisbytutdrag")
        self.radioButton_ExportDisbytutdrag.setText("Utdrag för Disbyt")

        self.checkBox_ExportDisbytutdrag_Johan = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_ExportDisbytutdrag_Johan.setChecked(True)
        self.checkBox_ExportDisbytutdrag_Johan.setObjectName("checkBox_HelaDatabasen_Johan")
        self.checkBox_ExportDisbytutdrag_Johan.setEnabled(False)

        self.checkBox_ExportDisbytutdrag_Gedcom = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_ExportDisbytutdrag_Gedcom.setChecked(True)
        self.checkBox_ExportDisbytutdrag_Gedcom.setObjectName("checkBox_HelaDatabasen_Gedcom")
        self.checkBox_ExportDisbytutdrag_Gedcom.setEnabled(False)


        self.radioButton_ExportWebbutdrag = QtGui.QRadioButton(self.Utdragsval_widget)
        self.radioButton_ExportWebbutdrag.setChecked(False)
        self.radioButton_ExportWebbutdrag.setObjectName("radioButton_ExportWebbutdrag")
        self.radioButton_ExportWebbutdrag.setText("Utdrag för webb")

        self.checkBox_ExportWebbutdrag_Johan = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_ExportWebbutdrag_Johan.setChecked(True)
        self.checkBox_ExportWebbutdrag_Johan.setObjectName("checkBox_HelaDatabasen_Johan")
        self.checkBox_ExportWebbutdrag_Johan.setEnabled(False)

        self.checkBox_ExportWebbutdrag_Gedcom = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_ExportWebbutdrag_Gedcom.setChecked(False)
        self.checkBox_ExportWebbutdrag_Gedcom.setObjectName("checkBox_HelaDatabasen_Gedcom")
        self.checkBox_ExportWebbutdrag_Gedcom.setEnabled(False)


        self.radioButton_SärskiltUtdrag = QtGui.QRadioButton(self.Utdragsval_widget)
        self.radioButton_SärskiltUtdrag.setObjectName("radioButton_SärskiltUtdrag")
        self.radioButton_SärskiltUtdrag.setText("Särskilt Utdrag")

        self.checkBox_SärskiltUtdrag_Johan = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_SärskiltUtdrag_Johan.setChecked(True)
        self.checkBox_SärskiltUtdrag_Johan.setObjectName("checkBox_HelaDatabasen_Johan")
        self.checkBox_SärskiltUtdrag_Johan.setEnabled(False)

        self.checkBox_SärskiltUtdrag_Gedcom = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_SärskiltUtdrag_Gedcom.setChecked(False)
        self.checkBox_SärskiltUtdrag_Gedcom.setObjectName("checkBox_HelaDatabasen_Gedcom")
        self.checkBox_SärskiltUtdrag_Gedcom.setEnabled(False)


        self.radioButton_Delmängder = QtGui.QRadioButton(self.Utdragsval_widget)
        self.radioButton_Delmängder.setObjectName("radioButton_Delmängder")
        self.radioButton_Delmängder.setText("Uppdelning i delmängder")

        self.checkBox_Delmängder_Johan = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_Delmängder_Johan.setChecked(True)
        self.checkBox_Delmängder_Johan.setObjectName("checkBox_HelaDatabasen_Johan")
        self.checkBox_Delmängder_Johan.setEnabled(False)

        self.checkBox_Delmängder_Gedcom = QtGui.QCheckBox(self.Utdragsval_widget)
        self.checkBox_Delmängder_Gedcom.setChecked(False)
        self.checkBox_Delmängder_Gedcom.setObjectName("checkBox_HelaDatabasen_Gedcom")
        self.checkBox_Delmängder_Gedcom.setEnabled(False)






        self.label_NyRad = QtGui.QLabel(self.NyRad_widget)
        self.label_NyRad.setObjectName("label_NyRad")
        self.label_NyRad.setText("Gedcom, NyRad-format")

        self.radioButton_Unix = QtGui.QRadioButton(self.NyRad_widget)
        self.radioButton_Unix.setChecked(False)
        self.radioButton_Unix.setText("Unix")
        self.radioButton_Unix.setObjectName("checkBox_Unix")

        self.radioButton_Windows = QtGui.QRadioButton(self.NyRad_widget)
        self.radioButton_Windows.setChecked(False)
        self.radioButton_Windows.setText("Windows")
        self.radioButton_Windows.setObjectName("checkBox_Windows")




        self.label_Kodning = QtGui.QLabel(self.NyRad_widget)
        self.label_Kodning.setObjectName("label_Kodning")
        self.label_Kodning.setText("Gedcom, kodning")

        self.comboBox_Kodning = sijComboBox(self.NyRad_widget)
        self.comboBox_Kodning.setObjectName("comboBox_Kodning")
        self.comboBox_Kodning.addItems(["ANSEL","UTF-8", "iso-8859-1"])

# KODNING vid Gedcom-export
# Gedcom 5.5 föreskriver "ASCII" och att där så krävs ska användas "ANSEL".
# För svenska krävs följaktligen ANSEL. Detta är normalinställningen i detta program.
#
# Programmet kan också använda de kodningar för vilka Python3.1 innehåller 'encode'-
# och 'decode'-funktioner. # För att använda sådan kodning ska benämningen enligt
# http://docs.python.org/py3k/library/codecs.html#standard-encodings
# införas i  "self.comboBox_Kodning.addItems" ovan. Stavning, inkl. användning av gemener
# och versaler, ska överensstämma exakt med referensen.
#
# Härutöver kan programmet koda utf8 med beteckningsstavning "UTF-8".
# Denna beteckning accepteras av johan-programmet importera.py.
#
# OBS! Varje annan kodning är ASCII och ANSEL är en avvikelse från gedcomstandarden
# och kan inte användas om man inte känner till att mottagande program kan
# hantera kodningen.

# För Python 2, se  http://docs.python.org/library/codecs.html#standard-encodings

# Se också eventuella kommentarer i Johans importprogram importera.py. (Sök "Konvertera från fil")



        self.label_Startperson = QtGui.QLabel(self.left_widget)
        self.label_Startperson.setObjectName("label_Startperson")
        self.label_Startperson.setText("Välj person att starta på")

        self.lineEdit_Startperson = sijLineEdit(self.left_widget)
        self.lineEdit_Startperson.setAlignment(Qt.AlignCenter)
        self.lineEdit_Startperson.setText("00000000")
        self.lineEdit_Startperson.setObjectName("lineEdit_Startperson")


        self.checkBox_Räknamarkeringar = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Räknamarkeringar.setChecked(False)
        self.checkBox_Räknamarkeringar.setText("Räkna/visa markeringar")
        self.checkBox_Räknamarkeringar.setObjectName("checkBox_Räknamarkeringar")


        self.checkBox_BBryt = QtGui.QCheckBox(self.left_widget)
        self.checkBox_BBryt.setChecked(True)
        self.checkBox_BBryt.setObjectName("checkBox_BBryt")
        self.checkBox_BBryt.setText("Tag bort bortom B-markerade personer")

        self.checkBox_Extrabryt = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Extrabryt.setObjectName("checkBox_Extrabryt")
        self.checkBox_Extrabryt.setText("Tag bort bortom följande personer")

        self.textEdit_Extrabryt =sijTextEdit(self.left_widget)
        self.textEdit_Extrabryt.setObjectName("textEdit_Extrabryt")



        self.checkBox_Amarkerade = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Amarkerade.setEnabled(False)
        self.checkBox_Amarkerade.setChecked(True)
        self.checkBox_Amarkerade.setObjectName("checkBox_Amarkerade")
        self.checkBox_Amarkerade.setText("Tag bort A-markerade personer")

        self.checkBox_Bmarkerade = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Bmarkerade.setEnabled(False)
        self.checkBox_Bmarkerade.setChecked(True)
        self.checkBox_Bmarkerade.setObjectName("checkBox_Bmarkerade")
        self.checkBox_Bmarkerade.setText("Tag bort B-markerade personer")

        self.checkBox_Cmarkerade = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Cmarkerade.setEnabled(False)
        self.checkBox_Cmarkerade.setChecked(True)
        self.checkBox_Cmarkerade.setObjectName("checkBox_Cmarkerade")
        self.checkBox_Cmarkerade.setText("Tag bort C-markerade personer")

        self.checkBox_1markerade = QtGui.QCheckBox(self.left_widget)
        self.checkBox_1markerade.setEnabled(False)
        self.checkBox_1markerade.setChecked(True)
        self.checkBox_1markerade.setObjectName("checkBox_1markerade")
        self.checkBox_1markerade.setText("Tag med 1-markerade personer")






        self.checkBox_Käntdöda = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Käntdöda.setChecked(True)
        self.checkBox_Käntdöda.setObjectName("checkBox_Käntdöda")
        self.checkBox_Käntdöda.setText("Tag med känt avlidna för mer än ")

        self.checkBox_Okäntdöda = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Okäntdöda.setChecked(True)
        self.checkBox_Okäntdöda.setObjectName("checkBox_Okäntdöda")
        self.checkBox_Okäntdöda.setText("Tag med känt födda för mer än ")



        self.lineEdit_Käntdöda = sijLineEdit(self.left_widget)
        self.lineEdit_Käntdöda.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.lineEdit_Käntdöda.setObjectName("lineEdit_Käntdöda")
        self.lineEdit_Käntdöda.setText("25")

        self.label_Käntdöda = QtGui.QLabel(self.left_widget)
        self.label_Käntdöda.setObjectName("label_Käntdöda")
        self.label_Käntdöda.setText("år sedan")


        self.lineEdit_Okäntdöda = sijLineEdit(self.left_widget)
        self.lineEdit_Okäntdöda.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.lineEdit_Okäntdöda.setObjectName("lineEdit_Okäntdöda")
        self.lineEdit_Okäntdöda.setText("110")

        self.label_Okäntdöda = QtGui.QLabel(self.left_widget)
        self.label_Okäntdöda.setObjectName("label_Okäntdöda")
        self.label_Okäntdöda.setText("år sedan")



        self.checkBox_Nivå1_dok = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Nivå1_dok.setChecked(False)
        self.checkBox_Nivå1_dok.setObjectName("checkBox_Nivå1_dok")
        self.checkBox_Nivå1_dok.setText("Tag med nivå1-dokument")

        self.checkBox_Nivå2_dok = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Nivå2_dok.setChecked(False)
        self.checkBox_Nivå2_dok.setObjectName("checkBox_Nivå2_dok")
        self.checkBox_Nivå2_dok.setText("Tag med nivå2-dokument")


        self.checkBox_wget_skript = QtGui.QCheckBox(self.left_widget)
        self.checkBox_wget_skript.setChecked(False)
        self.checkBox_wget_skript.setObjectName("checkBox_wget_skript")
        self.checkBox_wget_skript.setText("Generera skript för senare återläsning från Disbyt")
        self.checkBox_wget_skript.setEnabled(False)
        self.checkBox_wget_skript.setVisible(False)


        self.pushButton_Startaexport = QtGui.QPushButton(self.left_widget)
        self.pushButton_Startaexport.setObjectName("pushButton_Startaexport")
        self.pushButton_Startaexport.setText("Starta Export")


        self.textEdit_logg =sijTextEdit(self.mainwidget)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.setVerticalScrollBarPolicy   ( Qt.ScrollBarAlwaysOn )
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAsNeeded )

#        print "Exit setupUi (gui_Exportera)"
        return
###################################################################################################




###################################################################################################
    def enableUi(self):

        return
###################################################################################################




###################################################################################################
# Anpassning av storlekarna på de grafiska elementen när fontstorlek ändras.

    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()
        self.ritaom()
        return
###################################################################################################




###################################################################################################
    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()
        self.ritaom()
        return
###################################################################################################




###################################################################################################
    def fontsizeset(self):

#        print "font size set =", self.fontsize

        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

#        self.scrollyta.setFont(font)
        self.mainwidget.setFont(font)

        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)

        self.label_Nydatabas.setFont(font)
        self.lineEdit_Nydatabas.setFont(font)
        self.pushButton_Nydatabas.setFont(font)

        self.label_Resultatformat.setFont(font)
        self.label_Johanformat.setFont(font)
        self.label_Gedcomformat.setFont(font)

        self.checkBox_HelaDatabasen_Johan.setFont(font)
        self.checkBox_HelaDatabasen_Gedcom.setFont(font)

        self.checkBox_ExportDisbytutdrag_Johan.setFont(font)
        self.checkBox_ExportWebbutdrag_Johan.setFont(font)
        self.checkBox_SärskiltUtdrag_Johan.setFont(font)
        self.checkBox_Delmängder_Johan.setFont(font)

        self.checkBox_ExportDisbytutdrag_Gedcom.setFont(font)
        self.checkBox_ExportWebbutdrag_Gedcom.setFont(font)
        self.checkBox_SärskiltUtdrag_Gedcom.setFont(font)
        self.checkBox_Delmängder_Gedcom.setFont(font)


        self.radioButton_HelaDatabasen.setFont(font)
        self.radioButton_ExportDisbytutdrag.setFont(font)
        self.radioButton_ExportWebbutdrag.setFont(font)
        self.radioButton_SärskiltUtdrag.setFont(font)
        self.radioButton_Delmängder.setFont(font)


        self.label_NyRad.setFont(font)
        self.radioButton_Unix.setFont(font)
        self.radioButton_Windows.setFont(font)

        self.label_Kodning.setFont(font)
        self.comboBox_Kodning.setFont(font)

        self.pushButton_Startaexport.setFont(font)

        self.checkBox_Räknamarkeringar.setFont(font)
        self.label_Startperson.setFont(font)
        self.lineEdit_Startperson.setFont(font)



        self.checkBox_BBryt.setFont(font)
        self.checkBox_Extrabryt.setFont(font)
        self.textEdit_Extrabryt.setFont(font)


        self.checkBox_Amarkerade.setFont(font)
        self.checkBox_Bmarkerade.setFont(font)
        self.checkBox_Cmarkerade.setFont(font)
        self.checkBox_1markerade.setFont(font)

        self.checkBox_Käntdöda.setFont(font)
        self.checkBox_Okäntdöda.setFont(font)

        self.lineEdit_Käntdöda.setFont(font)
        self.lineEdit_Okäntdöda.setFont(font)
        self.label_Käntdöda.setFont(font)
        self.label_Okäntdöda.setFont(font)

        self.checkBox_Nivå1_dok.setFont(font)
        self.checkBox_Nivå2_dok.setFont(font)

        self.checkBox_wget_skript.setFont(font)
        self.textEdit_logg.setFont(font)

#        self.scrollyta.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_logg.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_logg.horizontalScrollBar().setFixedHeight(fh)

#        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

# Layout av rutan frame_top högst uppe till vänster

        b1 = fs + max (      metrics.width(self.label_Databas.text()),       metrics.width(self.label_Nydatabas.text()) )
        b3 = fs + max ( metrics.width(self.pushButton_Databas.text()), metrics.width( self.pushButton_Nydatabas.text()) )

        self.label_Databas.setGeometry          (                                           2,                                           2,   metrics.width(self.label_Databas.text()), fh )
        self.label_Nydatabas.setGeometry        (                                           2,  2 + self.label_Databas.geometry().bottom(), metrics.width(self.label_Nydatabas.text()), fh )

        self.lineEdit_Databas.setGeometry       (                                           b1,                                          2,                                      60*fs, fh )
        self.lineEdit_Nydatabas.setGeometry     (                                           b1, 2 + self.label_Databas.geometry().bottom(),   self.lineEdit_Databas.geometry().width(), fh )

        self.pushButton_Databas.setGeometry     ( 2 + self.lineEdit_Databas.geometry().right(),                                          2,                                         b3, fh )
        self.pushButton_Nydatabas.setGeometry   ( 2 + self.lineEdit_Databas.geometry().right(), 2 + self.label_Databas.geometry().bottom(),                                         b3, fh )



# Layout av rutan Utdragsval_widget (separat ruta för 2 radiobuttons)
        self.label_Resultatformat.setGeometry           ( 2,                                                           2,                  metrics.width(self.label_Resultatformat.text()), fh )
        self.radioButton_HelaDatabasen.setGeometry      ( 2,    fs/2 + 2 + self.label_Resultatformat.geometry().bottom(),      3*fs + metrics.width(self.radioButton_HelaDatabasen.text()), fh )
        self.radioButton_ExportDisbytutdrag.setGeometry ( 2,      2 + self.radioButton_HelaDatabasen.geometry().bottom(), 3*fs + metrics.width(self.radioButton_ExportDisbytutdrag.text()), fh )
        self.radioButton_ExportWebbutdrag.setGeometry   ( 2, 2 + self.radioButton_ExportDisbytutdrag.geometry().bottom(),   3*fs + metrics.width(self.radioButton_ExportWebbutdrag.text()), fh )
        self.radioButton_SärskiltUtdrag.setGeometry     ( 2,   2 + self.radioButton_ExportWebbutdrag.geometry().bottom(),     3*fs + metrics.width(self.radioButton_SärskiltUtdrag.text()), fh )
        self.radioButton_Delmängder.setGeometry         ( 2,     2 + self.radioButton_SärskiltUtdrag.geometry().bottom(),         3*fs + metrics.width(self.radioButton_Delmängder.text()), fh )




        b4 = 0
        for each in (self.label_Resultatformat, self.radioButton_HelaDatabasen, self.radioButton_ExportDisbytutdrag, self.radioButton_ExportWebbutdrag, self.radioButton_SärskiltUtdrag, self.radioButton_Delmängder):
            if b4 < each.geometry().right():
                b4 = each.geometry().right()
#       b4 är högerkanten efter alla radioButtons

        for each in (self.checkBox_HelaDatabasen_Johan, self.checkBox_HelaDatabasen_Gedcom, \
            self.checkBox_ExportDisbytutdrag_Johan, self.checkBox_ExportDisbytutdrag_Gedcom, \
            self.checkBox_ExportWebbutdrag_Johan, self.checkBox_ExportWebbutdrag_Gedcom, \
            self.checkBox_SärskiltUtdrag_Johan, self.checkBox_SärskiltUtdrag_Gedcom, \
            self.checkBox_Delmängder_Johan, self.checkBox_Delmängder_Gedcom  ):
            each.setFixedSize( fh, fh)

        b5 = b4 + self.checkBox_HelaDatabasen_Johan.geometry().width()
#       b5 är mitt mellan två kolumner checkboxar

        self.label_Johanformat.setGeometry     ( b5 - (fh + metrics.width(self.label_Johanformat.text()))/2, fh/2,  metrics.width(self.label_Johanformat.text()), fh )
        self.label_Gedcomformat.setGeometry    (                                                  b5 + fh/2, fh/2, metrics.width(self.label_Gedcomformat.text()), fh )

        self.label_Resultatformat.move         ( self.label_Johanformat.geometry().left() - self.label_Resultatformat.geometry().width(), fh/2 )

        b6 = b5 +  metrics.width(self.label_Gedcomformat.text())/2

        self.checkBox_HelaDatabasen_Johan.move       ( b4,      self.radioButton_HelaDatabasen.geometry().top() )
        self.checkBox_HelaDatabasen_Gedcom.move      ( b6,      self.radioButton_HelaDatabasen.geometry().top() )
        self.checkBox_ExportDisbytutdrag_Johan.move  ( b4, self.radioButton_ExportDisbytutdrag.geometry().top() )
        self.checkBox_ExportDisbytutdrag_Gedcom.move ( b6, self.radioButton_ExportDisbytutdrag.geometry().top() )
        self.checkBox_ExportWebbutdrag_Johan.move    ( b4,   self.radioButton_ExportWebbutdrag.geometry().top() )
        self.checkBox_ExportWebbutdrag_Gedcom.move   ( b6,   self.radioButton_ExportWebbutdrag.geometry().top() )
        self.checkBox_SärskiltUtdrag_Johan.move      ( b4,     self.radioButton_SärskiltUtdrag.geometry().top() )
        self.checkBox_SärskiltUtdrag_Gedcom.move     ( b6,     self.radioButton_SärskiltUtdrag.geometry().top() )
        self.checkBox_Delmängder_Johan.move          ( b4,         self.radioButton_Delmängder.geometry().top() )
        self.checkBox_Delmängder_Gedcom.move         ( b6,         self.radioButton_Delmängder.geometry().top() )




# Layout av rutan NyRad_widget (separat ruta för 2 radiobuttons)
        self.label_NyRad.setGeometry         (                                           2, 2,         3*fs + metrics.width(self.label_NyRad.text()), fh )
        self.radioButton_Unix.setGeometry    (     2 + self.label_NyRad.geometry().right(), 2,    3*fs + metrics.width(self.radioButton_Unix.text()), fh )
        self.radioButton_Windows.setGeometry (2 + self.radioButton_Unix.geometry().right(), 2, 3*fs + metrics.width(self.radioButton_Windows.text()), fh )

        self.label_Kodning.setGeometry       (                                           2, 2 + self.label_NyRad.geometry().bottom(),         3*fs + metrics.width(self.label_NyRad.text()), fh )
        self.comboBox_Kodning.setGeometry    (     2 + self.label_NyRad.geometry().right(), 2 + self.label_NyRad.geometry().bottom(),         3*fs + metrics.width(" ANSEL "),  fh )




# Layout av rutan left_widget

        b2 = 2*fs + max(metrics.width(self.checkBox_Käntdöda.text()), metrics.width(self.checkBox_Okäntdöda.text()))
        groupboxwidth = 35*fs
        pushbuttonwidth = fs + metrics.width(self.pushButton_Startaexport.text())

        self.label_Startperson.setGeometry         (                                                2,                                                       2,               metrics.width( self.label_Startperson.text()),     fh )
        self.lineEdit_Startperson.setGeometry      ( 2*fs + self.label_Startperson.geometry().right(),                 self.label_Startperson.geometry().top(),                                  metrics.width("000000000"),     fh )
        self.checkBox_Räknamarkeringar.setGeometry (                                                2,          2 + self.label_Startperson.geometry().bottom(), 4*fs + metrics.width(self.checkBox_Räknamarkeringar.text()),     fh )

        self.checkBox_BBryt.setGeometry            (                                                2, 2 + self.checkBox_Räknamarkeringar .geometry().bottom(),            4*fs + metrics.width(self.checkBox_BBryt.text()),     fh )
        self.checkBox_Extrabryt.setGeometry        (                                                2,             2 + self.checkBox_BBryt.geometry().bottom(),        4*fs + metrics.width(self.checkBox_Extrabryt.text()),     fh )
        self.textEdit_Extrabryt.setGeometry        (                                                2,         4 + self.checkBox_Extrabryt.geometry().bottom(),                                               groupboxwidth,   4*fh )

        self.checkBox_Amarkerade.setGeometry       (                                                2,         2 + self.textEdit_Extrabryt.geometry().bottom(),      4*fs + metrics.width( self.checkBox_Amarkerade.text()),     fh )
        self.checkBox_Bmarkerade.setGeometry       (                                                2,        2 + self.checkBox_Amarkerade.geometry().bottom(),      4*fs + metrics.width( self.checkBox_Bmarkerade.text()),     fh )
        self.checkBox_Cmarkerade.setGeometry       (                                                2,        2 + self.checkBox_Bmarkerade.geometry().bottom(),      4*fs + metrics.width( self.checkBox_Cmarkerade.text()),     fh )

        self.checkBox_Käntdöda.setGeometry         (                                                2,        2 + self.checkBox_Cmarkerade.geometry().bottom(),                                                          b2,     fh )
        self.checkBox_Okäntdöda.setGeometry        (                                                2,          2 + self.checkBox_Käntdöda.geometry().bottom(),                                                          b2,     fh )

        self.lineEdit_Käntdöda.setGeometry         (   fs + self.checkBox_Käntdöda.geometry().right(),                 self.checkBox_Käntdöda.geometry().top(),                                       metrics.width("0000"),     fh )
        self.lineEdit_Okäntdöda.setGeometry        (   fs + self.checkBox_Käntdöda.geometry().right(),                self.checkBox_Okäntdöda.geometry().top(),                                       metrics.width("0000"),     fh )
        self.label_Käntdöda.setGeometry            (   fs + self.lineEdit_Käntdöda.geometry().right(),                 self.lineEdit_Käntdöda.geometry().top(),                   metrics.width(self.label_Käntdöda.text()),     fh )
        self.label_Okäntdöda.setGeometry           (   fs + self.lineEdit_Käntdöda.geometry().right(),                self.lineEdit_Okäntdöda.geometry().top(),                  metrics.width(self.label_Okäntdöda.text()),     fh )

        self.checkBox_1markerade.setGeometry       (                                                2,         2 + self.checkBox_Okäntdöda.geometry().bottom(),      4*fs + metrics.width( self.checkBox_1markerade.text()),     fh )


        self.checkBox_Nivå1_dok.setGeometry        (                                                2,        2 + self.checkBox_1markerade.geometry().bottom(),       4*fs + metrics.width( self.checkBox_Nivå1_dok.text()),     fh )
        self.checkBox_Nivå2_dok.setGeometry        (                                                2,         2 + self.checkBox_Nivå1_dok.geometry().bottom(),       4*fs + metrics.width( self.checkBox_Nivå2_dok.text()),     fh )


        self.checkBox_wget_skript.setGeometry      (                                                2,         2 + self.checkBox_Nivå2_dok.geometry().bottom(),    4*fs +  metrics.width( self.checkBox_wget_skript.text()),     fh )

        self.pushButton_Startaexport.setGeometry   (         groupboxwidth - pushbuttonwidth - 3*fh/2,    fh/2 + self.checkBox_wget_skript.geometry().bottom(),                                             pushbuttonwidth,     fh )




# Placering av rutorna

        self.top_widget.move          ( 0, 0 )
        self.top_widget.resize        ( 2 + self.pushButton_Nydatabas.geometry().right(), 2 + self.pushButton_Nydatabas.geometry().bottom() )

        self.Utdragsval_widget.move   ( 0, fh/2 + self.top_widget.geometry().bottom() )
        self.Utdragsval_widget.resize ( 2 + self.label_Gedcomformat.geometry().right(), 2 + self.checkBox_Delmängder_Gedcom.geometry().bottom() )

        self.NyRad_widget.move        ( 0, fh/2 +  self.Utdragsval_widget.geometry().bottom() )
        self.NyRad_widget.resize      ( 2 + self.radioButton_Windows.geometry().right(), 2 + self.comboBox_Kodning.geometry().bottom() )

        self.left_widget.move         ( 0, fh/2 +  self.NyRad_widget.geometry().bottom() )
        self.left_widget.resize       ( 2 + self.textEdit_Extrabryt.geometry().right(), fh/2 + self.pushButton_Startaexport.geometry().bottom() )







        self.textEdit_logg.move ( 2+self.left_widget.geometry().right(), self.Utdragsval_widget.geometry().top() )

        self.textEdit_logg.setFixedSize ( self.top_widget.geometry().width()  -  self.left_widget.geometry().width(),    self.left_widget.geometry().bottom() - self.top_widget.geometry().bottom() )

        self.textEdit_logg.verticalScrollBar().show()

        self.mainwidget.move   ( 0, 0 )
        self.mainwidget.resize ( 2 + self.textEdit_logg.geometry().right(), 2 + self.textEdit_logg.geometry().bottom() )


        availablescreen_Rect = QtGui.QDesktopWidget().availableGeometry()
#        screen_Rect = QtGui.QDesktopWidget().screenGeometry()

        self.resize ( self.mainwidget.geometry().width(),  self.mainwidget.geometry().height() )

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

        self.textEdit_logg.geometry().setWidth ( self.mainwidget.geometry().right()  - self.textEdit_logg.geometry().left() - 2 )
        self.textEdit_logg.geometry().setHeight( self.mainwidget.geometry().bottom() - self.textEdit_logg.geometry().top() - 2 )

        self.textEdit_logg.setVerticalScrollBarPolicy   ( Qt.ScrollBarAsNeeded )
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAsNeeded )

        return
###################################################################################################




###################################################################################################
    def ui_connections(self):

        for each in [self.lineEdit_Databas,
                     self.lineEdit_Nydatabas,
                     self.lineEdit_Startperson,
                     self.textEdit_Extrabryt,
                     self.textEdit_logg,
                     self.lineEdit_Käntdöda,
                     self.lineEdit_Okäntdöda,
                     self.comboBox_Kodning]:

            self.connect(each, SIGNAL("CtrlPlusPressed"),  self.fontsizeup   )
            self.connect(each, SIGNAL("CtrlMinusPressed"), self.fontsizedown )

        return
###################################################################################################
