#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_kontrollera.py

# Senast ändrad: 2011-02-28  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTextEdit
############################################################################




############################################################################
class gui_Kontrollera(object):

    SenastÄndrad = '2011-02-28 18:59:34'  # Uppdateras automatiskt. Ändra inte manuellt.

############################################################################
    def setupUi(self, Kontrollera):

# Gränsytans statiska definitioner

        Kontrollera.setObjectName("Kontrollera")
        Kontrollera.setWindowTitle("Kontrollera databas")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))


        self.scrollyta = QtGui.QScrollArea(Kontrollera)
        self.setCentralWidget(self.scrollyta)
        self.scrollyta.setFrameStyle(QFrame.NoFrame)
        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("centralwidget")
        self.scrollyta.setFocusPolicy(Qt.NoFocus)

        self.mainwidget = QtGui.QWidget()
        self.scrollyta.setWidget(self.mainwidget)
        self.mainwidget.setObjectName("mainwidget")
        self.mainwidget.setFocusPolicy(Qt.NoFocus)
        self.mainwidget.setAutoFillBackground(True)



        self.top_widget = QtGui.QWidget(self.mainwidget)
        self.left_widget = QtGui.QWidget(self.mainwidget)



#---------------------------------------------------------------------------------------
        self.label_Databas = QtGui.QLabel(self.top_widget)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas")

        self.lineEdit_Databas = sijLineEdit(self.top_widget)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.top_widget)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText("Välj databas")
#        self.pushButton_Databas.setIcon(QIcon("ikoner/32x32/J.png"))


#---------------------------------------------------------------------------------------

        self.checkBox_Fas0 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas0.setChecked(True)
        self.checkBox_Fas0.setObjectName("checkBox_Fas0")
        self.checkBox_Fas0.setText("Generera innehållslistor")
        self.checkBox_Fas0.setEnabled(False)
        self.checkBox_Fas0.setVisible(True)

        self.checkBox_Fas1 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas1.setChecked(False)
        self.checkBox_Fas1.setObjectName("checkBox_Fas1")
        self.checkBox_Fas1.setText("Kontroll av filstruktur")
        self.checkBox_Fas1.setEnabled(True)
        self.checkBox_Fas1.setVisible(True)

        self.checkBox_Fas2 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas2.setChecked(False)
        self.checkBox_Fas2.setObjectName("checkBox_Fas2")
        self.checkBox_Fas2.setText("Kontroll av länkning mellan filer")
        self.checkBox_Fas2.setEnabled(True)
        self.checkBox_Fas2.setVisible(True)

        self.checkBox_Fas3 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas3.setChecked(False)
        self.checkBox_Fas3.setObjectName("checkBox_Fas3")
        self.checkBox_Fas3.setText("Kontroll av taggar")
        self.checkBox_Fas3.setEnabled(True)
        self.checkBox_Fas3.setVisible(True)

        self.checkBox_Fas4 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas4.setChecked(False)
        self.checkBox_Fas4.setObjectName("checkBox_Fas4")
        self.checkBox_Fas4.setText("Generera kategorilistor")
        self.checkBox_Fas4.setEnabled(True)
        self.checkBox_Fas4.setVisible(True)

        self.checkBox_Fas5 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas5.setChecked(False)
        self.checkBox_Fas5.setObjectName("checkBox_Fas5")
        self.checkBox_Fas5.setText("Kontrollera församlingsnamn")
        self.checkBox_Fas5.setEnabled(True)
        self.checkBox_Fas5.setVisible(True)

        self.checkBox_Fas6 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas6.setChecked(False)
        self.checkBox_Fas6.setObjectName("checkBox_Fas6")
        self.checkBox_Fas6.setText("Komplettera person- och parkataloger med namntext")
        self.checkBox_Fas6.setEnabled(True)
        self.checkBox_Fas6.setVisible(True)


        self.checkBox_Fas7 = QtGui.QCheckBox(self.left_widget)
        self.checkBox_Fas7.setChecked(False)
        self.checkBox_Fas7.setObjectName("checkBox_Fas7")
        self.checkBox_Fas7.setText("Kontrollera pars upplösning")
        self.checkBox_Fas7.setEnabled(False)
        self.checkBox_Fas7.setVisible(False)




        self.pushButton_Starta = QtGui.QPushButton(self.left_widget)
        self.pushButton_Starta.setObjectName("pushButton_Starta")
        self.pushButton_Starta.setText("Starta\nkontroll")
#        self.pushButton_Starta.setIcon(QIcon("ikoner/32x32/J.png"))


#---------------------------------------------------------------------------------------
        self.textEdit_logg = sijTextEdit(self.mainwidget)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.setVerticalScrollBarPolicy ( Qt.ScrollBarAlwaysOn)
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAsNeeded )

#        print "Exit setupUi (gui_Kontrollera)"
        return
###################################################################################################




###################################################################################################
    def enableUi(self):

        return
###################################################################################################




###################################################################################################
# Anpassning av storlekarna på de grafiska elementen när fontstorlek ändras.

    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):

#        print "font size set =", self.fontsize

        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.scrollyta.setFont(font)
        self.mainwidget.setFont(font)

        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.textEdit_logg.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.pushButton_Starta.setFont(font)

        self.ritaom()

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        b1 = 2*fs + metrics.width(self.label_Databas.text())
        b3 = 2*fs + metrics.width(self.pushButton_Databas.text())

        self.label_Databas.setGeometry      (                                            2,                                           2, metrics.width(self.label_Databas.text()),   fh )
        self.lineEdit_Databas.setGeometry   (                                           b1,                                           2,                                    60*fs,   fh )
        self.pushButton_Databas.setGeometry ( 2 + self.lineEdit_Databas.geometry().right(),                                           2,                                       b3,  fh )



        self.checkBox_Fas0.setGeometry ( 2,                                          2, 4*fs + metrics.width( self.checkBox_Fas0.text()), fh )
        self.checkBox_Fas1.setGeometry ( 2, 2 + self.checkBox_Fas0.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas1.text()), fh )
        self.checkBox_Fas2.setGeometry ( 2, 2 + self.checkBox_Fas1.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas2.text()), fh )
        self.checkBox_Fas3.setGeometry ( 2, 2 + self.checkBox_Fas2.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas3.text()), fh )
        self.checkBox_Fas4.setGeometry ( 2, 2 + self.checkBox_Fas3.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas4.text()), fh )
        self.checkBox_Fas5.setGeometry ( 2, 2 + self.checkBox_Fas4.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas5.text()), fh )
        self.checkBox_Fas6.setGeometry ( 2, 2 + self.checkBox_Fas5.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas6.text()), fh )
        self.checkBox_Fas7.setGeometry ( 2, 2 + self.checkBox_Fas6.geometry().bottom(), 4*fs + metrics.width( self.checkBox_Fas7.text()), fh )

        b4 = 0
        for cb in [ self.checkBox_Fas0, self.checkBox_Fas1, self.checkBox_Fas2, self.checkBox_Fas3, self.checkBox_Fas4, self.checkBox_Fas5, self.checkBox_Fas6, self.checkBox_Fas7 ] :
            if b4 < cb.geometry().width():
                b4 = cb.geometry().width()

        pushbuttonstartawidth = 2*fs + metrics.width(self.pushButton_Starta.text())
        if b4 < pushbuttonstartawidth:
            b4 = pushbuttonstartawidth

        b5 = 0
        rader = self.pushButton_Starta.text().split('\n')
        for rad in rader:
            if b5 < metrics.width(rad):
                b5 = metrics.width(rad)

        self.pushButton_Starta.setGeometry ( 2 + b4 - pushbuttonstartawidth, 2 + self.checkBox_Fas7.geometry().bottom(), 4*fs + b5, len(rader) * fh )


        self.left_widget.move         ( 0, fh/2 + self.top_widget.geometry().bottom() )
        self.left_widget.resize       ( 2 + b4, fh/2 + self.pushButton_Starta.geometry().bottom() )


        self.textEdit_logg.setGeometry (2 + self.left_widget.geometry().right(), self.left_widget.geometry().top(), 60*fs, 20*fh )


        self.textEdit_logg.verticalScrollBar().show()

        self.mainwidget.setGeometry ( 0, 0, 2 + self.textEdit_logg.geometry().right(), 2 + self.textEdit_logg.geometry().bottom()  )

        self.resize ( 2 + self.mainwidget.geometry().width(),  2 + self.mainwidget.geometry().height()  )

        return
###################################################################################################




###################################################################################################
    def tablelayout(self):

        return
################v###################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.textEdit_logg.setUpdatesEnabled(False)

        self.textEdit_logg.setMaximumSize (QtCore.QSize(16777215, 16777215))
        self.mainwidget.resize(QtCore.QSize( self.geometry().width(), self.geometry().height() ))


        textEdit_logg_Rect = QtCore.QRect( self.textEdit_logg.geometry() )

        if self.geometry().right()  > self.pushButton_Databas.geometry().right():
            textEdit_logg_Rect.setRight( self.mainwidget.geometry().right() )
        else:
            textEdit_logg_Rect.setRight( self.lineEdit_Databas.geometry().right() )

        textEdit_logg_Rect.setBottom( self.mainwidget.geometry().bottom() )

        self.textEdit_logg.setGeometry ( textEdit_logg_Rect )
        self.textEdit_logg.setMaximumSize (QtCore.QSize( self.textEdit_logg.geometry().width(), self.textEdit_logg.geometry().height()  ))
        self.textEdit_logg.setVerticalScrollBarPolicy ( Qt.ScrollBarAlwaysOn)
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAsNeeded )

        self.textEdit_logg.setUpdatesEnabled(True)

#        print "Exit resizeEvent"

        return
###################################################################################################




###################################################################################################
    def ui_connections(self):

#       Kopplingar, signaler i gui till slots i gui_
#       Ytterligare kopplingar, signaler i gui till slots i kontrollera.py, finns i kontrollera.py/mera_ui_connections(self)

        self.connect(self.lineEdit_Databas, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_logg, SIGNAL("CtrlPlusPressed"), self.fontsizeup)

        self.connect(self.lineEdit_Databas, SIGNAL("CtrlMinusPressed"), self.fontsizedown)
        self.connect(self.textEdit_logg, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        return
###################################################################################################
