#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# johanklasser.py

# Senast ändrad: 2011-01-05  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
import inspect

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

# OBS johanklasser och johangemensamt får inte importera allting från varandra.
# Cirkelberoende kan uppstå.

# I sättHändelsestorlek, rad ca 480 nedan finns
# from johangemensamt import allmänt as allm


############################################################################
# Här finns
# class johanpersonfil()                : anor, exportera, importera_gedcom_tråd, inh, johangemensamt
                                        # johanklasser, johan, kontrollera, parblad, parlista,
                                        # personblad, personlista, ättlingar,

# class johanparfil()                   : anor, exportera, importera_gedcom_tråd,  johanklasser, johan,
                                        # jämföra, kontrollera, parblad, parlista, personblad,
                                        # personlista, ättlingar,

# class sijLineEdit(QLineEdit)          : johanklasser, gui_anor, gui_exportera, gui_inh,
                                        # gui_parblad, gui_parlista, gui_personblad, gui_personlista,
                                        # gui_ättlingar, gui_johan, gui_jämföra, gui_kontrollera,
                                        # gui_nydatabas

# class sijTableWidget(QTableWidget)    : johanklasser,  gui_inh, gui_johan, gui_parblad,
                                        # gui_parlista, gui_personblad, gui_personlista,
                                        # gui_ättlingar

# class sijTextEdit(QTextEdit)          : johanklasser, gui_exportera, gui_inh, gui_johan,
                                        # gui_jämföra, gui_kontollera, gui_nydatabas, gui_parblad,
                                        # gui_parlista, gui_personblad, gui_personlista

# class sijComboBox(QComboBox)          :johanklasser, gui_exportera

# class Händelseruta( QtCore.QObject)   :
#
########################################################################################
class johanpersonfil():

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args, **kwargs):
        for k, v in list(kwargs.items()):
            setattr(self, k, v)

PersonXML = johanpersonfil(person_ID = "",
    föräldrapar_ID = "",
    egna_par_ID = "",
    bonusrelation_ID = "",


# Att hämtas direkt ur personfilen:
    förnamn = "",      #  tabell med \n mellan raderna och \t mellan fälten
    tilltal = "",      #  tabell med \n mellan raderna och \t mellan fälten
    efternamn = "",    #  tabell med \n mellan raderna och \t mellan fälten

# Att skapas efter hämtning, ur hämtat innehåll
    allaförnamn = "",      # alla förnamn, med mellanslag, utan anteckning
    allatilltal = "",      # alla tilltal, med mellanslag, utan anteckning
    allaefternamn = "",    # alla efternamn, med mellanslag, utan anteckning

    allaförnamnmedant = "",      # alla förnamn, formaterad, med anteckningar
    allatilltalmedant = "",      # alla tilltal, formaterad, med anteckningar
    allaefternamnmedant = "",    # alla efternamn, formaterad, med anteckningar

    kortnamn = "",        # första tilltal/första förnamn, mellanslag, första efternamn, utan anteckningar
    långtnamn = "",           # alla förnamn och första efternamn, med mellanslag, utan anteckningar
    långtnamnmedant = "",         # alla förnamn och alla efternamn, formaterat, med anteckningar


    person_kön = "",
    person_kategori = "",
    född_år = "",
    född_månad = "",
    född_dag = "",
    född_gata = "",
    född_by = "",
    född_kvarter = "",
    född_socken = "",
    född_församling = "",
    född_disbytförsamling = "",
    född_stad = "",
    född_härad = "",
    född_län = "",
    född_utrikesplats = "",
    född_källa = "",
    död_år = "",
    död_månad = "",
    död_dag = "",
    död_gata = "",
    död_by = "",
    död_kvarter = "",
    död_socken = "",
    död_församling = "",
    död_disbytförsamling = "",
    död_stad = "",
    död_härad = "",
    död_län = "",
    död_utrikesplats = "",
    död_källa = "",
    fler_källor = "",
    anteckning = "",
    senastsparat = "")
########################################################################################




########################################################################################
class johanparfil():

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args, **kwargs):
        for k, v in list(kwargs.items()):
            setattr(self, k, v)

ParXML = johanparfil(par_ID = "",
    person1_ID = "",
    person2_ID = "",
    bonusrelation_ID = "",
    inledn_typ = "",
    inledn_år = "",
    inledn_månad = "",
    inledn_dag = "",
    inledn_gata = "",
    inledn_by = "",
    inledn_kvarter = "",
    inledn_socken = "",
    inledn_församling = "",
    inledn_disbytförsamling = "",
    inledn_stad = "",
    inledn_härad = "",
    inledn_län = "",
    inledn_utrikesplats = "",
    inledn_källa = "",
    upplösn_typ = "",
    upplösn_år = "",
    upplösn_månad = "",
    upplösn_dag = "",
    upplösn_gata = "",
    upplösn_by = "",
    upplösn_kvarter = "",
    upplösn_socken = "",
    upplösn_församling = "",
    upplösn_disbytförsamling = "",
    upplösn_stad = "",
    upplösn_härad = "",
    upplösn_län = "",
    upplösn_utrikesplats = "",
    upplösn_källa = "",
    barn_ID = "",
    fler_källor = "",
    anteckning = "",
    senastsparat = "")
########################################################################################




####################################################################
class sijLineEdit(QLineEdit):

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args):
        QLineEdit.__init__(self, *args)

    def event(self, event):
        if (event.type()==QEvent.KeyPress):
            if event.modifiers() & Qt.ControlModifier:
                if event.key()==Qt.Key_Plus:
                    self.emit(SIGNAL("CtrlPlusPressed"))
                    return True
                elif event.key()==Qt.Key_Minus:
                    self.emit(SIGNAL("CtrlMinusPressed"))
                    return True
                elif event.key()==Qt.Key_S:
                    self.emit(SIGNAL("Ctrl_S_Pressed"))
                    return True
        return QLineEdit.event(self, event)
####################################################################




####################################################################
class sijTableWidget(QTableWidget):

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args):
        QTableWidget.__init__(self, *args)

    def event(self, event):
        if (event.type()==QEvent.KeyPress):
            if event.modifiers() & Qt.ControlModifier:
                if event.key()==Qt.Key_Plus:
                    self.emit(SIGNAL("CtrlPlusPressed"))
                    return True
                elif event.key()==Qt.Key_Minus:
                    self.emit(SIGNAL("CtrlMinusPressed"))
                    return True
                elif event.key()==Qt.Key_S:
                    self.emit(SIGNAL("Ctrl_S_Pressed"))
                    return True
        return QTableWidget.event(self, event)

    def edit(self, index, trigger, event):
        if QTableWidget.edit(self, index, trigger, event):
            print ('edit, rad=' + str(index.row()) + ', kolumn=' + str(index.column()))
            return True
        return False
####################################################################




####################################################################
class sijTextEdit(QTextEdit):

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args):
        QTextEdit.__init__(self, *args)

    def event(self, event):
        if (event.type()==QEvent.KeyPress):
            if event.modifiers() & Qt.ControlModifier:
                if event.key()==Qt.Key_Plus:
                    self.emit(SIGNAL("CtrlPlusPressed"))
                    return True
                elif event.key()==Qt.Key_Minus:
                    self.emit(SIGNAL("CtrlMinusPressed"))
                    return True
                elif event.key()==Qt.Key_S:
                    self.emit(SIGNAL("Ctrl_S_Pressed"))
                    return True
        return QTextEdit.event(self, event)
####################################################################




####################################################################
class sijComboBox(QComboBox):

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

    def __init__(self, *args):
        QComboBox.__init__(self, *args)

    def event(self, event):
        if (event.type()==QEvent.KeyPress):
            if event.modifiers() & Qt.ControlModifier:
                if event.key()==Qt.Key_Plus:
                    self.emit(SIGNAL("CtrlPlusPressed"))
                    return True
                elif event.key()==Qt.Key_Minus:
                    self.emit(SIGNAL("CtrlMinusPressed"))
                    return True
                elif event.key()==Qt.Key_S:
                    self.emit(SIGNAL("Ctrl_S_Pressed"))
                    return True
        return QComboBox.event(self, event)
####################################################################




####################################################################
class Händelseruta( QtCore.QObject):

    SenastÄndrad = '2011-01-05 20:00:49'  # Uppdateras automatiskt. Ändra inte manuellt.

# Händelseruta avser  'född'  och   'död'    i personblad
#              samt  'inledn' och ' upplösn' i parblad.




####################################################################
    def __init__(self, parent, fontsiz):

        QtCore.QObject.__init__(self, parent)
        Händelseruta.setObjectName(self, "Händelseruta")

        self.skapa(parent)

        self.sättHändelsestorlek(fontsiz)

        return
####################################################################




####################################################################
    def skapa(self,parent):
# Här skapas objekten i händelserutan
# Här sätts fasta texter i objekten

# typsnitt/font ställs in senare
# storlekar och placeringar ställs in senare


        self.groupBox_Händelse = QtGui.QGroupBox(parent)
        self.groupBox_Händelse.setAutoFillBackground(True)


        self.groupBox_typ = QtGui.QGroupBox(self.groupBox_Händelse)
        self.groupBox_datum = QtGui.QGroupBox(self.groupBox_Händelse)
        self.groupBox_plats = QtGui.QGroupBox(self.groupBox_Händelse)
        self.groupBox_källa = QtGui.QGroupBox(self.groupBox_Händelse)

        self.groupBox_typ.setTitle("Typ")
        self.groupBox_datum.setTitle("Datum")
        self.groupBox_plats.setTitle("Plats")
        self.groupBox_källa.setTitle("Källor")



        self.lineEdit_typ =  sijLineEdit(self.groupBox_typ)



        self.label_dag = QtGui.QLabel(self.groupBox_datum)
        self.lineEdit_dag = sijLineEdit(self.groupBox_datum)
        self.label_månad = QtGui.QLabel(self.groupBox_datum)
        self.lineEdit_månad = sijLineEdit(self.groupBox_datum)
        self.label_år = QtGui.QLabel(self.groupBox_datum)
        self.lineEdit_år = sijLineEdit(self.groupBox_datum)



        self.label_gata = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_gata = sijLineEdit(self.groupBox_plats)
        self.label_by = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_by = sijLineEdit(self.groupBox_plats)
        self.label_kvarter = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_kvarter = sijLineEdit(self.groupBox_plats)
        self.label_socken = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_socken = sijLineEdit(self.groupBox_plats)
        self.label_församling = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_församling = sijLineEdit(self.groupBox_plats)
        self.label_disbytförsamling = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_disbytförsamling = sijLineEdit(self.groupBox_plats)
        self.label_stad = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_stad = sijLineEdit(self.groupBox_plats)
        self.label_härad = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_härad = sijLineEdit(self.groupBox_plats)
        self.label_län = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_län = sijLineEdit(self.groupBox_plats)
        self.label_utrikesplats = QtGui.QLabel(self.groupBox_plats)
        self.lineEdit_utrikesplats = sijLineEdit(self.groupBox_plats)


        self.textEdit_källa = sijTextEdit(self.groupBox_källa)


        self.label_dag.setText("Dag")
        self.label_månad.setText("Månad")
        self.label_år.setText("År")
        self.label_gata.setText("Gata")
        self.label_by.setText("By")
        self.label_kvarter.setText("Kvarter")
        self.label_socken.setText("Socken")
        self.label_församling.setText("Församling")
        self.label_disbytförsamling.setText("Disbytförsamling")
        self.label_stad.setText("Stad")
        self.label_härad.setText("Härad")
        self.label_län.setText("Län")
        self.label_utrikesplats.setText("Utrikes plats")



        self.label_dag.setBuddy(self.lineEdit_dag)
        self.label_månad.setBuddy(self.lineEdit_månad)
        self.label_år.setBuddy(self.lineEdit_år)
        self.label_gata.setBuddy(self.lineEdit_gata)
        self.label_by.setBuddy(self.lineEdit_by)
        self.label_kvarter.setBuddy(self.lineEdit_kvarter)
        self.label_socken.setBuddy(self.lineEdit_socken)
        self.label_församling.setBuddy(self.lineEdit_församling)
        self.label_disbytförsamling.setBuddy(self.lineEdit_disbytförsamling)
        self.label_stad.setBuddy(self.lineEdit_stad)
        self.label_härad.setBuddy(self.lineEdit_härad)
        self.label_län.setBuddy(self.lineEdit_län)
        self.label_utrikesplats.setBuddy(self.lineEdit_utrikesplats)

        self.lineEdit_typ.setObjectName("lineEdit_typ")

        self.label_dag.setObjectName("label_dag")
        self.lineEdit_dag.setObjectName("lineEdit_dag")
        self.label_månad.setObjectName("label_månad")
        self.lineEdit_månad.setObjectName("lineEdit_månad")
        self.label_år.setObjectName("label_år")
        self.lineEdit_år.setObjectName("lineEdit_år")

        self.label_gata.setObjectName("label_gata")
        self.lineEdit_gata.setObjectName("lineEdit_gata")
        self.label_by.setObjectName("label_by")
        self.lineEdit_by.setObjectName("lineEdit_by")
        self.label_kvarter.setObjectName("label_kvarter")
        self.lineEdit_kvarter.setObjectName("lineEdit_kvarter")
        self.label_socken.setObjectName("label_socken")
        self.lineEdit_socken.setObjectName("lineEdit_socken")
        self.label_församling.setObjectName("label_församling")
        self.lineEdit_församling.setObjectName("lineEdit_församling")
        self.label_disbytförsamling.setObjectName("label_disbytförsamling")
        self.lineEdit_disbytförsamling.setObjectName("lineEdit_disbytförsamling")
        self.label_stad.setObjectName("label_stad")
        self.lineEdit_stad.setObjectName("lineEdit_stad")
        self.label_härad.setObjectName("label_härad")
        self.lineEdit_härad.setObjectName("lineEdit_härad")
        self.label_län.setObjectName("label_län")
        self.lineEdit_län.setObjectName("lineEdit_län")
        self.label_utrikesplats.setObjectName("label_utrikesplats")
        self.lineEdit_utrikesplats.setObjectName("lineEdit_utrikesplats")

        self.textEdit_källa.setObjectName("textEdit_källa")

        self.groupBox_Händelse.setTabOrder(self.lineEdit_typ,                self.lineEdit_år)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_år,                 self.lineEdit_månad)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_månad,              self.lineEdit_dag)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_dag,                self.lineEdit_gata)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_gata,               self.lineEdit_by)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_by,                 self.lineEdit_kvarter)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_kvarter,            self.lineEdit_socken)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_socken,             self.lineEdit_församling)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_församling,         self.lineEdit_disbytförsamling)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_disbytförsamling,   self.lineEdit_stad)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_stad,               self.lineEdit_härad)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_härad,              self.lineEdit_län)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_län,                self.lineEdit_utrikesplats)
        self.groupBox_Händelse.setTabOrder(self.lineEdit_utrikesplats,       self.textEdit_källa)
        self.groupBox_Händelse.setTabOrder(self.textEdit_källa,              self.lineEdit_typ)

        return
#####################################################################



#####################################################################
# OBS! det finns flera rutiner med namnet 'sättstorlek'
# Denna 'sättstorlek' hör hemma i 'class Händelseruta'
    def sättHändelsestorlek(self,fntsiz):

# OBS johanklasser och johangemensamt får inte importera allting från varandra.
# Cirkelberoende kan uppstå.

        from johangemensamt import allmänt as allm

        font = QtGui.QFont()
        font.setPointSize(fntsiz)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        splitlength = 2*fs
        delta=5



# groupbox Plats -----
        label = [ "Gata", "By", "Kvarter", "Socken", "Församling", "Disbytförsaml.", "Stad", "Härad", "Län", "Utrikes plats" ]

        radhöjd = fh
        labelwidth = 0
        i=0
        for widg in [self.label_gata, self.label_by, self.label_kvarter, self.label_socken, self.label_församling, self.label_disbytförsamling, self.label_stad, self.label_härad, self.label_län, self.label_utrikesplats]:
            widg.setText(label[i])
            if labelwidth <  metrics.width(widg.text()):
                labelwidth = metrics.width(widg.text())
            i=i+1

        vänstermarg = 3
        föregående = 0.9*fh
        for widg in [self.label_gata, self.label_by, self.label_kvarter, self.label_socken, self.label_församling, self.label_disbytförsamling, self.label_stad, self.label_härad, self.label_län, self.label_utrikesplats]:
            widg.setGeometry(vänstermarg, föregående, labelwidth, fh)
            föregående = föregående + radhöjd +1

        textwidth = 30*fs
        vänstermarg = 3 + labelwidth + delta
        föregående = 0.9*fh
        for widg in [self.lineEdit_gata, self.lineEdit_by, self.lineEdit_kvarter, self.lineEdit_socken, self.lineEdit_församling, self.lineEdit_disbytförsamling, self.lineEdit_stad, self.lineEdit_härad, self.lineEdit_län, self.lineEdit_utrikesplats]:
            widg.setGeometry(vänstermarg, föregående, textwidth, fh)
            föregående = föregående + radhöjd +1
# --------------------



# groupbox Typ -------
        vänstermarg = 3
        föregående = 0.9*fh
        lineEditWidth = labelwidth + delta + textwidth
        self.lineEdit_typ.setGeometry(vänstermarg, föregående, lineEditWidth, fh)
# --------------------



# groupbox Datum -----
        vänstermarg = 3
        föregående = 0.9*fh

        l1 = metrics.width(self.label_år.text())
        l2 = metrics.width(self.label_månad.text())
        l3 = metrics.width(self.label_dag.text())

        datelineEditwidth = (lineEditWidth -l1 -l2 -l3 -2*splitlength - 3*delta)/3


        lineEdit_dag_Rect = QtCore.QRect()
        lineEdit_månad_Rect = QtCore.QRect()
        lineEdit_år_Rect = QtCore.QRect()

        label_dag_Rect = QtCore.QRect()
        label_månad_Rect = QtCore.QRect()
        label_år_Rect = QtCore.QRect()



        lineEdit_dag_Rect.setTop(föregående)
        lineEdit_månad_Rect.setTop(föregående)
        lineEdit_år_Rect.setTop(föregående)

        label_dag_Rect.setTop(föregående)
        label_månad_Rect.setTop(föregående)
        label_år_Rect.setTop(föregående)



        lineEdit_dag_Rect.setHeight(fh)
        lineEdit_månad_Rect.setHeight(fh)
        lineEdit_år_Rect.setHeight(fh)

        label_dag_Rect.setHeight(fh)
        label_månad_Rect.setHeight(fh)
        label_år_Rect.setHeight(fh)



        label_år_Rect.setLeft(vänstermarg)
        label_år_Rect.setWidth(l1)
        self.label_år.setGeometry(label_år_Rect)

        lineEdit_år_Rect.setLeft(label_år_Rect.right() + delta)
        lineEdit_år_Rect.setWidth(datelineEditwidth)
        self.lineEdit_år.setGeometry(lineEdit_år_Rect)

        label_månad_Rect.setLeft(lineEdit_år_Rect.right() + splitlength)
        label_månad_Rect.setWidth(l2)
        self.label_månad.setGeometry(label_månad_Rect)

        lineEdit_månad_Rect.setLeft(label_månad_Rect.right() + delta)
        lineEdit_månad_Rect.setWidth(datelineEditwidth)
        self.lineEdit_månad.setGeometry(lineEdit_månad_Rect)

        label_dag_Rect.setLeft(lineEdit_månad_Rect.right() + splitlength)
        label_dag_Rect.setWidth(l3)
        self.label_dag.setGeometry(label_dag_Rect)

        lineEdit_dag_Rect.setLeft(label_dag_Rect.right() + delta)
        lineEdit_dag_Rect.setWidth(datelineEditwidth)
        self.lineEdit_dag.setGeometry(lineEdit_dag_Rect)
# --------------------



# groupbox Källa -----
        vänstermarg = 0
        föregående = 0.9*fh
        self.textEdit_källa.setGeometry(vänstermarg, föregående,  vänstermarg + labelwidth + delta + textwidth, 4*fh)
# --------------------



# groupBox_Händelse -----
        vänstermarg = 0
        topptitelmarg = 0.7*fh
        titelmarg = 0.3*fh
        bottenmarg = 3
        högermarg = 2

        groupBox_typ_Rect = QtCore.QRect()
        groupBox_datum_Rect = QtCore.QRect()
        groupBox_plats_Rect = QtCore.QRect()
        groupBox_källa_Rect = QtCore.QRect()

        groupboxbredd = vänstermarg + self.lineEdit_utrikesplats.geometry().right() + högermarg

        groupBox_plats_Rect.setWidth(vänstermarg + self.lineEdit_utrikesplats.geometry().right())
        groupBox_plats_Rect.setHeight(bottenmarg + self.lineEdit_utrikesplats.geometry().bottom())


        self.lineEdit_typ.setGeometry(vänstermarg, föregående, lineEditWidth, fh)

        groupBox_typ_Rect.setLeft( vänstermarg)
        groupBox_typ_Rect.setTop(topptitelmarg)
        groupBox_typ_Rect.setWidth(groupboxbredd)
        groupBox_typ_Rect.setHeight(bottenmarg +self.lineEdit_typ.geometry().bottom())
        self.groupBox_typ.setGeometry(groupBox_typ_Rect)


        groupBox_datum_Rect.setLeft( vänstermarg)
        groupBox_datum_Rect.setTop(titelmarg + self.groupBox_typ.geometry().bottom())
        groupBox_datum_Rect.setWidth(groupboxbredd)
        groupBox_datum_Rect.setHeight(bottenmarg + self.lineEdit_dag.geometry().bottom())
        self.groupBox_datum.setGeometry(groupBox_datum_Rect)


        groupBox_plats_Rect.setLeft( vänstermarg)
        groupBox_plats_Rect.setTop(titelmarg + self.groupBox_datum.geometry().bottom())
        groupBox_plats_Rect.setWidth(groupboxbredd)
        groupBox_plats_Rect.setHeight(bottenmarg + self.lineEdit_utrikesplats.geometry().bottom())

        self.groupBox_plats.setGeometry(groupBox_plats_Rect)


        groupBox_källa_Rect.setLeft( vänstermarg)
        groupBox_källa_Rect.setTop(titelmarg +self.groupBox_plats.geometry().bottom())
        groupBox_källa_Rect.setWidth(groupboxbredd)
        groupBox_källa_Rect.setHeight( bottenmarg + self.textEdit_källa.geometry().bottom())
        self.groupBox_källa.setGeometry(groupBox_källa_Rect)



        groupBox_Händelse_Rect = QtCore.QRect()
        groupBox_Händelse_Rect.setLeft(0)
        groupBox_Händelse_Rect.setTop(0)
        groupBox_Händelse_Rect.setRight (self.groupBox_källa.geometry().right())
        groupBox_Händelse_Rect.setBottom (self.groupBox_källa.geometry().bottom())
        self.groupBox_Händelse.setGeometry(groupBox_Händelse_Rect)

        return
######################################################################################
