#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_johan.py

# Senast ändrad: 2011-02-13  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTableWidget, sijTextEdit
############################################################################




###################################################################################################
class gui_Johan(object):

    SenastÄndrad = '2011-02-04 19:37:05'  # Uppdateras automatiskt. Ändra inte manuellt.

    Startpunkterkolumnbredder = [3, 45, 8, 25, 10]
    Startpunkterkolumnhuvud = ["rad", "Databas", "Person ID", "Namn", "Par ID"]

# OBS! Startpunkterkolumnbredder och Startpunkterkolumnhuvud ska definieras samhörande
# Startpunkterkolumnhuvud ställs in i setupUi
# Startpunkterkolumnbredder ställs in i sijLayout

    tabellBredd = 0
    tabellHöjd = 0


###################################################################################################
    def setupUi(self, Johan):
# Hela den grafiska gränsytan kodas här

        Johan.setObjectName("Johan")
#        Johan.setAcceptDrops(True)
        self.setAttribute(Qt.WA_AlwaysShowToolTips)
        self.setWindowTitle("Johan  ––  för python 3.1  ––  startsida")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))


        self.scrollyta = QtGui.QScrollArea(Johan)
        self.setCentralWidget(self.scrollyta)
        self.scrollyta.setFrameStyle(QFrame.NoFrame)
        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOff)   # { ScrollBarAsNeeded, ScrollBarAlwaysOff, ScrollBarAlwaysOn }
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("centralwidget")
        self.scrollyta.setFocusPolicy(Qt.NoFocus)

        self.mainwidget = QtGui.QWidget()
        self.scrollyta.setWidget(self.mainwidget)
        self.mainwidget.setObjectName("mainwidget")
        self.mainwidget.setFocusPolicy(Qt.NoFocus)


        self.label_Databas = QtGui.QLabel(self.mainwidget)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas ")

        self.lineEdit_Databas = sijLineEdit(self.mainwidget)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.mainwidget)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText(" Välj Databas ")

        self.label_Personnummer = QtGui.QLabel(self.mainwidget)
        self.label_Personnummer.setObjectName("label_Personnummer")
        self.label_Personnummer.setText("Person-nr. ")

        self.lineEdit_Personnummer = sijLineEdit(self.mainwidget)
        self.lineEdit_Personnummer.setObjectName("lineEdit_Personnummer")
        self.lineEdit_Personnummer.setAlignment(Qt.AlignCenter)

        self.label_Parnummer = QtGui.QLabel(self.mainwidget)
        self.label_Parnummer.setObjectName("label_Parnummer")
        self.label_Parnummer.setText("Par-nr. ")

        self.lineEdit_Parnummer = sijLineEdit(self.mainwidget)
        self.lineEdit_Parnummer.setObjectName("lineEdit_Parnummer")
        self.lineEdit_Parnummer.setAlignment(Qt.AlignCenter)
        self.lineEdit_Parnummer.setText("par00000000")

        self.label_Personnamn = QtGui.QLabel(self.mainwidget)
        self.label_Personnamn.setObjectName("label_Personnamn")
        self.label_Personnamn.setText("Person ")

        self.lineEdit_Personnamn = sijLineEdit(self.mainwidget)
        self.lineEdit_Personnamn.setObjectName("lineEdit_Personnamn")
        self.lineEdit_Personnamn.setAlignment(Qt.AlignLeft)
        self.lineEdit_Personnamn.setText("")

        self.pushButton_Anor = QtGui.QPushButton(self.mainwidget)
        self.pushButton_Anor.setObjectName("pushButton_Anor")
        self.pushButton_Anor.setText(" Visa anor ")

        self.pushButton_Ättlingar = QtGui.QPushButton(self.mainwidget)
        self.pushButton_Ättlingar.setObjectName("pushButton_Ättlingar")
        self.pushButton_Ättlingar.setText(" Visa ättlingar ")

        self.pushButton_Personblad = QtGui.QPushButton(self.mainwidget)
        self.pushButton_Personblad.setObjectName("pushButton_Personblad")
        self.pushButton_Personblad.setText(" Editera personblad ")

        self.pushButton_Parblad = QtGui.QPushButton(self.mainwidget)
        self.pushButton_Parblad.setObjectName("pushButton_Parblad")
        self.pushButton_Parblad.setText(" Editera parblad ")


        self.label_Startpunkter = QtGui.QLabel(self.mainwidget)
        self.label_Startpunkter.setObjectName("label_Startpunkter")
        self.label_Startpunkter.setText("Förvalda startpunkter: ")


        self.tableWidget_Startpunkter = sijTableWidget(self.mainwidget)
        self.tableWidget_Startpunkter.setObjectName("tableWidget_Startpunkter")
        self.tableWidget_Startpunkter.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_Startpunkter.setEditTriggers(QtGui.QAbstractItemView.NoEditTriggers)
        self.tableWidget_Startpunkter.setAlternatingRowColors(True)
        self.tableWidget_Startpunkter.setIconSize(QtCore.QSize(16,16))
        self.tableWidget_Startpunkter.setDragEnabled(True)
        self.tableWidget_Startpunkter.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Startpunkter.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Startpunkter.setTextElideMode(QtCore.Qt.ElideMiddle)
        self.tableWidget_Startpunkter.setVerticalScrollBarPolicy ( Qt.ScrollBarAlwaysOff )
        self.tableWidget_Startpunkter.setHorizontalScrollBarPolicy ( Qt.ScrollBarAlwaysOff )
        self.tableWidget_Startpunkter.setColumnCount(len(self.Startpunkterkolumnbredder))

        self.textEdit_logg = sijTextEdit(self.mainwidget)
        self.textEdit_logg.setObjectName("textEdit_logg")
        self.textEdit_logg.setVerticalScrollBarPolicy ( Qt.ScrollBarAsNeeded)
        self.textEdit_logg.setHorizontalScrollBarPolicy ( Qt.ScrollBarAlwaysOff )

        self.label_Personnummer.setBuddy(self.lineEdit_Personnummer)

        QtCore.QObject.connect(self.tableWidget_Startpunkter, QtCore.SIGNAL("cellClicked(int,int)"), self.väljdatabas)

        palette_Bakgrund = QtGui.QPalette()

        brush = QtGui.QBrush(QtGui.QColor(248,248,248))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Active,QtGui.QPalette.Window,brush)

        brush = QtGui.QBrush(QtGui.QColor(240,240,255))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Inactive,QtGui.QPalette.Window,brush)

        brush = QtGui.QBrush(QtGui.QColor(240,240,255))
        brush.setStyle(QtCore.Qt.SolidPattern)
        palette_Bakgrund.setBrush(QtGui.QPalette.Disabled,QtGui.QPalette.Window,brush)

        self.mainwidget.setPalette(palette_Bakgrund)
        self.mainwidget.setAutoFillBackground(True)

        return
###################################################################################################




###################################################################################################
    def enableUi(self):

#        self.pushButton_Anor.setEnabled(True)
#        self.pushButton_Ättlingar.setEnabled(True)
#        self.pushButton_Personblad.setEnabled(True)
#        self.pushButton_Parblad.setEnabled(True)

#        self.pushButton_Anor.setVisible(True)
#        self.pushButton_Ättlingar.setVisible(True)
#        self.pushButton_Personblad.setVisible(True)
#        self.pushButton_Parblad.setVisible(True)

        return
###################################################################################################




###################################################################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        font = QFont()
        font.setPointSize(self.fontsize)

        self.scrollyta.setFont(font)
        self.mainwidget.setFont(font)

        self.menuBar.setFont(font)


        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.label_Personnummer.setFont(font)
        self.lineEdit_Personnummer.setFont(font)
        self.label_Parnummer.setFont(font)
        self.lineEdit_Parnummer.setFont(font)
        self.label_Personnamn.setFont(font)
        self.lineEdit_Personnamn.setFont(font)
        self.label_Startpunkter.setFont(font)

        self.pushButton_Anor.setFont(font)
        self.pushButton_Ättlingar.setFont(font)
        self.pushButton_Personblad.setFont(font)
        self.pushButton_Parblad.setFont(font)

        self.tableWidget_Startpunkter.setFont(font)

        self.textEdit_logg.setFont(font)

        self.ritaom()
###################################################################################################




###################################################################################################
    def sijlayout(self):
# "Möblering" av de grafiska elementen, görs om efter ändring av fontstorlek

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.textEdit_logg.verticalScrollBar().setFixedWidth(fh)

        b1 = 2*fs + max ( metrics.width(self.label_Databas.text()), metrics.width(self.label_Personnamn.text())  )

        self.label_Databas.setGeometry         (                                                    2,                                               2,        metrics.width(self.label_Databas.text()),   fh )
        self.lineEdit_Databas.setGeometry      (                                                   b1,                                               2,                                           55*fs,   fh )
        self.pushButton_Databas.setGeometry    (         2 + self.lineEdit_Databas.geometry().right(),                                               2,   metrics.width(self.pushButton_Databas.text()),   fh )


        self.label_Personnamn.setGeometry      (                                                    2,   2 + self.lineEdit_Databas.geometry().bottom(),     metrics.width(self.label_Personnamn.text()),   fh )
        self.lineEdit_Personnamn.setGeometry   (                                                   b1,   2 + self.lineEdit_Databas.geometry().bottom(),                                           25*fs,   fh )


        self.label_Personnummer.setGeometry    (   4*fs + self.lineEdit_Personnamn.geometry().right(),   2 + self.lineEdit_Databas.geometry().bottom(),   metrics.width(self.label_Personnummer.text()),   fh )
        self.lineEdit_Personnummer.setGeometry (       2 + self.label_Personnummer.geometry().right(),   2 + self.lineEdit_Databas.geometry().bottom(),                metrics.width("00000000") + 2*fs,   fh )

        self.label_Parnummer.setGeometry       ( 4*fs + self.lineEdit_Personnummer.geometry().right(),   2 + self.lineEdit_Databas.geometry().bottom(),      metrics.width(self.label_Parnummer.text()),   fh )
        self.lineEdit_Parnummer.setGeometry    (          2 + self.label_Parnummer.geometry().right(),   2 + self.lineEdit_Databas.geometry().bottom(),             metrics.width("par00000000") + 2*fs,   fh )

        self.pushButton_Anor.setGeometry       (                                                   b1, 2 + self.lineEdit_Parnummer.geometry().bottom(),      metrics.width(self.pushButton_Anor.text()),   fh )
        self.pushButton_Ättlingar.setGeometry  (          2 + self.pushButton_Anor.geometry().right(), 2 + self.lineEdit_Parnummer.geometry().bottom(), metrics.width(self.pushButton_Ättlingar.text()),   fh )
        self.pushButton_Personblad.setGeometry ( self.lineEdit_Personnummer.frameGeometry().right() - metrics.width(self.pushButton_Personblad.text()), 2 + self.lineEdit_Parnummer.geometry().bottom(), metrics.width(self.pushButton_Personblad.text()),  fh )
        self.pushButton_Parblad.setGeometry    (    self.lineEdit_Parnummer.frameGeometry().right() - metrics.width(self.pushButton_Parblad.text())   , 2 + self.lineEdit_Parnummer.geometry().bottom(),    metrics.width(self.pushButton_Parblad.text()),  fh )

        self.label_Startpunkter.setGeometry    (                                                    2, 2 + self.pushButton_Parblad.geometry().bottom(),   metrics.width(self.label_Startpunkter.text()),   fh )

        self.tableWidget_Startpunkter.move (2, 2 +  self.label_Startpunkter.geometry().bottom() )

        return
###################################################################################################




###################################################################################################
    def tablelayout(self):

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()


        self.tableWidget_Startpunkter.verticalHeader().setVisible(False)
        self.tableWidget_Startpunkter.setIconSize(QtCore.QSize(16,16))
        self.tableWidget_Startpunkter.verticalScrollBar().setFixedWidth(fh)
        self.tableWidget_Startpunkter.horizontalScrollBar().setFixedHeight(fh)


        self.tabellBredd = 0
        kol_nr = 0
        for kol in self.Startpunkterkolumnbredder:
            kol_bredd = int( kol * fs )
            self.tableWidget_Startpunkter.setColumnWidth(kol_nr, kol_bredd )
            self.tabellBredd = self.tabellBredd + kol_bredd
            kol_nr = kol_nr + 1

        kol_nr = 0
        for kol in self.Startpunkterkolumnhuvud:
            self.tableWidget_Startpunkter.setHorizontalHeaderItem(kol_nr, QtGui.QTableWidgetItem(kol))
            kol_nr = kol_nr + 1


# färdigställ tabellen och bestäm dess mått exklusive eventuell scrollist

        self.tabellHöjd = self.tableWidget_Startpunkter.horizontalHeader().height()
        radHöjd = fh
        for i in range (0, self.tableWidget_Startpunkter.rowCount()):
            self.tableWidget_Startpunkter.setRowHeight(i, radHöjd)
            self.tabellHöjd = self.tabellHöjd + radHöjd

            radnritem = QtGui.QTableWidgetItem( str(i+1) )      # strängen som ska skrivas som radnummer
            radnritem.setTextAlignment(Qt.Alignment(Qt.AlignRight))
            self.tableWidget_Startpunkter.setItem( i, 0, radnritem )

            self.tableWidget_Startpunkter.setCurrentCell(i, 2)
            tmpitem = self.tableWidget_Startpunkter.currentItem()
            if str(type(tmpitem)) != "<class 'NoneType'>":
                tmpitem.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
            self.tableWidget_Startpunkter.setCurrentItem( tmpitem )

            self.tableWidget_Startpunkter.setCurrentCell(i, 4)
            tmpitem = self.tableWidget_Startpunkter.currentItem()
            if str(type(tmpitem)) != "<class 'NoneType'>":
                tmpitem.setTextAlignment(Qt.Alignment(Qt.AlignCenter))
            self.tableWidget_Startpunkter.setCurrentItem( tmpitem )

        tillgängligBredd = 0.9*QtGui.QDesktopWidget().availableGeometry().width()
        if self.tabellBredd < tillgängligBredd :
            tabellStartpunkter_bredd = self.tabellBredd
        else:
            tabellStartpunkter_bredd = tillgängligBredd

        tillgängligHöjd = 0.9*QtGui.QDesktopWidget().availableGeometry().height() - self.label_Startpunkter.geometry().bottom()
        if self.tabellHöjd < tillgängligHöjd  :
            tabellStartpunkter_höjd = self.tabellHöjd
        else:
            tabellStartpunkter_höjd = tillgängligHöjd

        self.tableWidget_Startpunkter.resize(tabellStartpunkter_bredd, tabellStartpunkter_höjd)

        self.textEdit_logg.move (2, 2 +  self.tableWidget_Startpunkter.geometry().bottom() )

        return
#############################################################################################




###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        scrollytastorlek =  QtCore.QRect ( 0, 0,  4 + self.tableWidget_Startpunkter.geometry().right(),  4 + self.tableWidget_Startpunkter.geometry().bottom() + 10*fh )
        self.scrollyta.setGeometry  ( scrollytastorlek )
        self.mainwidget.setGeometry ( scrollytastorlek )

        self.textEdit_logg.resize(self.tableWidget_Startpunkter.geometry().width(), 10*fh)
        self.textEdit_logg.verticalScrollBar().show()

# QRect ( int x, int y, int width, int height )
        self.resize ( 2 + self.mainwidget.geometry().width(),  2 + self.mainwidget.geometry().height()  )

        return
###################################################################################################




###################################################################################################
    def resizeEvent(self, event):

# Anpassning av tabellen till fönstret på grund av användarens dragning av fönstrets kontur
# Hit kommer man magiskt, även efter storleksändringen vid första windowlayout()
#  Warning: resizing inside resizeEvent() or moveEvent() can lead to infinite recursion.

#        self.logga ("RESIZE EVENT, FONTSIZE= " + str(self.fontsize) + '\n')

        self.textEdit_logg.setUpdatesEnabled(False)

        self.textEdit_logg.setMaximumSize (QtCore.QSize(16777215, 16777215))
        self.mainwidget.resize(QtCore.QSize( self.geometry().width(), self.geometry().height() ))

        textEdit_logg_Rect = QtCore.QRect( self.textEdit_logg.geometry() )

        textEdit_logg_Rect.setRight ( self.mainwidget.geometry().right() - 2)
        textEdit_logg_Rect.setBottom( self.mainwidget.geometry().bottom() - 2)

        self.textEdit_logg.setGeometry ( textEdit_logg_Rect )
        self.textEdit_logg.setMaximumSize (QtCore.QSize( self.textEdit_logg.geometry().width(), self.textEdit_logg.geometry().height()  ))

        self.textEdit_logg.setUpdatesEnabled(True)

        return
###################################################################################################




###################################################################################################
# kopplingar till knappar i grafiska gränsytan
    def ui_connections(self):

# vad gör detta?
        QtCore.QMetaObject.connectSlotsByName(self)


        self.connect(self.lineEdit_Databas, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Databas, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Personnummer, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Personnummer, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Parnummer, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Parnummer, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.lineEdit_Personnamn, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.lineEdit_Personnamn, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.tableWidget_Startpunkter, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.tableWidget_Startpunkter, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        self.connect(self.textEdit_logg, SIGNAL("CtrlPlusPressed"), self.fontsizeup)
        self.connect(self.textEdit_logg, SIGNAL("CtrlMinusPressed"), self.fontsizedown)

        return
###################################################################################################




#############################################################################################
    def skapaStatiskMeny(self):

# Komplettering av statiska menyn görs i johan.py efter inläsning av ini-fil

        self.menuBar = QtGui.QMenuBar(self)
        self.menuBar.setObjectName("menuBar")
        self.setMenuBar(self.menuBar)



        self.menuArkiv = QtGui.QMenu(self.menuBar)
        self.menuArkiv.setObjectName("menuArkiv")
        self.menuArkiv.setTitle("Arkiv")
        self.menuBar.addAction(self.menuArkiv.menuAction())

        self.actionNy_databas = QtGui.QAction(self)
        self.actionNy_databas.setObjectName("actionNy_databas")
        self.actionNy_databas.setText("Ny databas med tom mall")
        self.menuArkiv.addAction(self.actionNy_databas)
        self.connect(self.actionNy_databas, QtCore.SIGNAL("triggered()"), self.NydatabasAct)

        self.actionNydatabas = QtGui.QAction(self)
        self.actionNydatabas.setObjectName("actionNydatabas")
        self.actionNydatabas.setText("Ny databas med gedcomimport")
        self.menuArkiv.addAction(self.actionNydatabas)
        self.connect(self.actionNydatabas, QtCore.SIGNAL("triggered()"), self.NydatabasAct)



        self.menuHjälp = QtGui.QMenu(self.menuBar)
        self.menuHjälp.setObjectName("menuHjälp")
        self.menuHjälp.setTitle("Hjälp")
        self.menuBar.addAction(self.menuHjälp.menuAction())


        self.actionOm = QtGui.QAction(self)
        self.actionOm.setObjectName("actionOm")
        self.actionOm.setText("Om Johan")
        self.menuHjälp.addAction(self.actionOm)
        self.connect(self.actionOm, QtCore.SIGNAL("triggered()"), self.OmJohanAct)


        self.menuLicenser = QtGui.QMenu(self.menuHjälp)
        self.menuLicenser.setObjectName("menuLicenser")
        self.menuLicenser.setTitle("Licenser")
        self.menuHjälp.addAction(self.menuLicenser.menuAction())

        self.actionGNU_GPL_v3_txt = QtGui.QAction(self)
        self.actionGNU_GPL_v3_txt.setObjectName("actionGNU_GPL_v3_txt")
        self.actionGNU_GPL_v3_txt.setText("GNU GPL v3 som text")
        self.menuLicenser.addAction(self.actionGNU_GPL_v3_txt)
        self.connect(self.actionGNU_GPL_v3_txt, QtCore.SIGNAL("triggered()"), self.OmGPL_txtAct)

        self.actionGNU_GPL_v3_www = QtGui.QAction(self)
        self.actionGNU_GPL_v3_www.setObjectName("actionGNU_GPL_v3_www")
        self.actionGNU_GPL_v3_www.setText("GNU GPL v3 - www.GNU.org")
        self.menuLicenser.addAction(self.actionGNU_GPL_v3_www)
        self.connect(self.actionGNU_GPL_v3_www, QtCore.SIGNAL("triggered()"), self.OmGPL_wwwAct)

        self.actionOmPython = QtGui.QAction(self)
        self.actionOmPython.setObjectName("actionOmPython")
        self.actionOmPython.setText("Python")
        self.menuLicenser.addAction(self.actionOmPython)
        self.connect(self.actionOmPython, QtCore.SIGNAL("triggered()"), self.OmPythonAct)

        self.actionOmPyQt4 = QtGui.QAction(self)
        self.actionOmPyQt4.setObjectName("actionOmPyQt4")
        self.actionOmPyQt4.setText("PyQt4")
        self.menuLicenser.addAction(self.actionOmPyQt4)
        self.connect(self.actionOmPyQt4, QtCore.SIGNAL("triggered()"), self.OmPyQt4Act)

        self.actionOmQt = QtGui.QAction(self)
        self.actionOmQt.setObjectName("actionOmQt")
        self.actionOmQt.setText("Qt")
        self.menuLicenser.addAction(self.actionOmQt)
        self.connect(self.actionOmQt, QtCore.SIGNAL("triggered()"), self.OmQtAct)


        self.menuBeskrivningar = QtGui.QMenu(self.menuHjälp)
        self.menuBeskrivningar.setObjectName("menuBeskrivningar")
        self.menuBeskrivningar.setTitle("Beskrivningar")
        self.menuHjälp.addAction(self.menuBeskrivningar.menuAction())

        self.actionInstallation = QtGui.QAction(self)
        self.actionInstallation.setObjectName("actionInstallation")
        self.actionInstallation.setText("Installation")
        self.menuBeskrivningar.addAction(self.actionInstallation)
        self.connect(self.actionInstallation, QtCore.SIGNAL("triggered()"), self.InstallationAct)

        self.actionProgram = QtGui.QAction(self)
        self.actionProgram.setObjectName("actionProgram")
        self.actionProgram.setText("Program")
        self.menuBeskrivningar.addAction(self.actionProgram)
        self.connect(self.actionProgram, QtCore.SIGNAL("triggered()"), self.ProgramAct)

        self.actionDatabas = QtGui.QAction(self)
        self.actionDatabas.setObjectName("actionDatabas")
        self.actionDatabas.setText("Databas")
        self.menuBeskrivningar.addAction(self.actionDatabas)
        self.connect(self.actionDatabas, QtCore.SIGNAL("triggered()"), self.DatabasAct)



        self.menuÅtgärder = QtGui.QMenu(self.menuBar)
        self.menuÅtgärder.setObjectName("menuÅtgärder")
        self.menuÅtgärder.setTitle("Åtgärder")
        self.menuBar.addAction(self.menuÅtgärder.menuAction())


        self.actionVisaPersonlista = QtGui.QAction(self)
        self.actionVisaPersonlista.setObjectName("actionVisaPersonlista")
        self.actionVisaPersonlista.setText("Visa personlista (kan ta lång tid)")
        self.menuÅtgärder.addAction(self.actionVisaPersonlista)
        self.connect(self.actionVisaPersonlista, QtCore.SIGNAL("triggered()"), self.VisaPersonlistaAct)

        self.actionVisaParlista = QtGui.QAction(self)
        self.actionVisaParlista.setObjectName("actionVisaParlista")
        self.actionVisaParlista.setText("Visa parlista (kan ta lång tid)")
        self.menuÅtgärder.addAction(self.actionVisaParlista)
        self.connect(self.actionVisaParlista, QtCore.SIGNAL("triggered()"), self.VisaParlistaAct)

        self.actionSkapaInnehållsFörteckningar = QtGui.QAction(self)
        self.actionSkapaInnehållsFörteckningar.setObjectName("actionSkapaInnehållsFörteckningar")
        self.actionSkapaInnehållsFörteckningar.setText("Skapa innehållsförteckningar (HTML)")
        self.menuÅtgärder.addAction(self.actionSkapaInnehållsFörteckningar)
        self.connect(self.actionSkapaInnehållsFörteckningar, QtCore.SIGNAL("triggered()"), self.SkapaInnehållsFörteckningarAct)

        if os.path.exists(os.path.join(self.programkatalog, "jämföra.py")):
            self.actionJämförDatabaser = QtGui.QAction(self)
            self.actionJämförDatabaser.setObjectName("actionJämförDatabaser")
            self.actionJämförDatabaser.setText("Jämför databaser")
            self.menuÅtgärder.addAction(self.actionJämförDatabaser)
            self.connect(self.actionJämförDatabaser, QtCore.SIGNAL("triggered()"), self.JämförDatabaserAct)

        self.actionKontrolleraDatabas = QtGui.QAction(self)
        self.actionKontrolleraDatabas.setObjectName("actionKontrolleraDatabas")
        self.actionKontrolleraDatabas.setText("Kontrollera databas")
        self.menuÅtgärder.addAction(self.actionKontrolleraDatabas)
        self.connect(self.actionKontrolleraDatabas, QtCore.SIGNAL("triggered()"), self.KontrolleraDatabasAct)

        self.actionExporteraDatabas = QtGui.QAction(self)
        self.actionExporteraDatabas.setObjectName("actionExporteraDatabas")
        self.actionExporteraDatabas.setText("Exportera databas")
        self.menuÅtgärder.addAction(self.actionExporteraDatabas)
        self.connect(self.actionExporteraDatabas, QtCore.SIGNAL("triggered()"), self.ExporteraDatabasAct)



        self.menuKälltexter = QtGui.QMenu(self.menuBar)
        self.menuKälltexter.setObjectName("menuKälltexter")
        self.menuKälltexter.setTitle("Källtexter")
        self.menuBar.addAction(self.menuKälltexter.menuAction())


        self.actionVisaProgramkod = QtGui.QAction(self)
        self.actionVisaProgramkod.setObjectName("actionVisaProgramkod")
        self.actionVisaProgramkod.setText("Programkod")
        self.menuKälltexter.addAction(self.actionVisaProgramkod)
        self.connect(self.actionVisaProgramkod, QtCore.SIGNAL("triggered()"), self.VisaProgramkodAct)

        self.actionVisaINIfil = QtGui.QAction(self)
        self.actionVisaINIfil.setObjectName("actionVisaINI-fil")
        self.actionVisaINIfil.setText("INI-fil")
        self.menuKälltexter.addAction(self.actionVisaINIfil)
        self.connect(self.actionVisaINIfil, QtCore.SIGNAL("triggered()"), self.VisaINIfilAct)


        return
#############################################################################################
