#!/usr/local/bin/python3
# -*- coding: utf-8 -*-

# gui_parblad.py

# Senast ändrad: 2011-01-10  - Uppdateras automatiskt. Ändra inte manuellt.
###########################################################################
#    Copyright (c) 2008, 2011 S Ingemar Johansson
#    ingemar at sijohansson dot com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License, version 3,
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################




############################################################################
import sys
import os
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from johanklasser import sijLineEdit, sijTableWidget, sijTextEdit, Händelseruta
############################################################################




####################################################################
class gui_Parblad(object):

    SenastÄndrad = '2011-01-10 18:22:08'  # Uppdateras automatiskt. Ändra inte manuellt.

####################################################################
    def setupUi(self, Parblad):

# Här definieras alla objekt inklusive fasta texter och statiska egenskaper
# Tabeller nollställs helt

# Storlekar och placeringar bestäms någon annanstans.

        Parblad.setObjectName("Parblad")
        Parblad.setWindowTitle("Johan - parblad")
        self.setWindowIcon(QIcon("ikoner/32x32/J.png"))

        self.ytteryta = QtGui.QWidget(Parblad)
        self.ytteryta.setObjectName("centralwidget")
        self.setCentralWidget(self.ytteryta)
        self.ytteryta.setAutoFillBackground(True)


        self.inneryta = QtGui.QWidget(self.ytteryta)
        self.inneryta.setObjectName("inneryta")
        self.inneryta.setAutoFillBackground(True)

        self.scrollyta = QtGui.QScrollArea(self.inneryta)

        self.scrollyta.setFrameStyle(QFrame.NoFrame)

        self.scrollyta.setVerticalScrollBarPolicy(Qt.ScrollBarAsNeeded)
        self.scrollyta.setHorizontalScrollBarPolicy(Qt.ScrollBarAsNeeded)
#        self.scrollyta.setAutoFillBackground(True)
        self.scrollyta.setObjectName("scrollyta")

        self.scrollyta.setFocusPolicy(Qt.NoFocus)
# sij tolkar att detta ärvs till alla underliggande objekt utom lineEdit, textEdit och tableWidget



# Rutan 'frame_top' högst uppe till vänster
        self.frame_top = QtGui.QFrame( self.inneryta)
        self.frame_top.setFrameShape(QtGui.QFrame.StyledPanel)
        self.frame_top.setFrameShadow(QtGui.QFrame.Raised)
        self.frame_top.setObjectName("frame_top")


        self.label_Databas = QtGui.QLabel(self.frame_top)
        self.label_Databas.setObjectName("label_Databas")
        self.label_Databas.setText("Databas ")
        self.label_Databas.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Databas = sijLineEdit(self.frame_top)
        self.lineEdit_Databas.setObjectName("lineEdit_Databas")

        self.pushButton_Databas = QtGui.QPushButton(self.frame_top)
        self.pushButton_Databas.setObjectName("pushButton_Databas")
        self.pushButton_Databas.setText(" Välj Databas ")


        self.label_Parnummer = QtGui.QLabel(self.frame_top)
        self.label_Parnummer.setObjectName("label_Parnummer")
        self.label_Parnummer.setText("Par-nr. ")
        self.label_Parnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_Parnummer = sijLineEdit(self.frame_top)
        self.lineEdit_Parnummer.setObjectName("lineEdit_Parnummer")
        self.lineEdit_Parnummer.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
        self.lineEdit_Parnummer.setText("00000000")
        self.lineEdit_Parnummer.setEnabled(False)

        self.pushButton_RitaOm = QtGui.QPushButton(self.frame_top)
        self.pushButton_RitaOm.setObjectName("pushButton_RitaOm")
        self.pushButton_RitaOm.setText("Rita om")
        self.pushButton_RitaOm.setEnabled(False)


        self.pushButton_Spara = QtGui.QPushButton(self.frame_top)
        self.pushButton_Spara.setObjectName("pushButton_Spara ")
        self.pushButton_Spara.setText("Spara")
        self.pushButton_Spara.setEnabled(False)

        self.label_Databas.setBuddy(self.lineEdit_Databas)
        self.label_Parnummer.setBuddy(self.lineEdit_Parnummer)


# Rutan 'groupBox_Par'

        self.groupBox_Par = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Par.setObjectName("groupBox_Par")
        self.groupBox_Par.setTitle("Par")


        self.label_Par_ID = QtGui.QLabel(self.groupBox_Par)
        self.label_Par_ID.setObjectName("label_Par_ID")
        self.label_Par_ID.setText("Par_ID")

        self.lineEdit_Par_ID = sijLineEdit(self.groupBox_Par)
        self.lineEdit_Par_ID.setObjectName("lineEdit_Par_ID")
        self.lineEdit_Par_ID.setEnabled(False)



        self.label_Person1_ID = QtGui.QLabel(self.groupBox_Par)
        self.label_Person1_ID.setObjectName("label_Person1_ID")
        self.label_Person1_ID.setText("Person 1, man / make - ID")

        self.lineEdit_Person1_ID = sijLineEdit(self.groupBox_Par)
        self.lineEdit_Person1_ID.setObjectName("lineEdit_Person1_ID")
        self.lineEdit_Person1_ID.setEnabled(False)

        self.label_Person1_namn = QtGui.QLabel(self.groupBox_Par)
        self.label_Person1_namn.setObjectName("label_Person1_namn")
        self.label_Person1_namn.setText("Namn")

        self.lineEdit_Person1_namn = sijLineEdit(self.groupBox_Par)
        self.lineEdit_Person1_namn.setObjectName("lineEdit_Person1_namn")
        self.lineEdit_Person1_namn.setEnabled(False)



        self.label_Person2_ID = QtGui.QLabel(self.groupBox_Par)
        self.label_Person2_ID.setObjectName("label_Person2_ID")
        self.label_Person2_ID.setText("Person 2, kvinna / maka - ID")

        self.lineEdit_Person2_ID = sijLineEdit(self.groupBox_Par)
        self.lineEdit_Person2_ID.setObjectName("lineEdit_Person2_ID")
        self.lineEdit_Person2_ID.setEnabled(False)

        self.label_Person2_namn = QtGui.QLabel(self.groupBox_Par)
        self.label_Person2_namn.setObjectName("label_Person2_namn")
        self.label_Person2_namn.setText("Namn")


        self.lineEdit_Person2_namn = sijLineEdit(self.groupBox_Par)
        self.lineEdit_Person2_namn.setObjectName("lineEdit_Person2_namn")
        self.lineEdit_Person2_namn.setEnabled(False)



# Rutan 'groupBox_Barn'
        self.groupBox_Egna_Barn = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Egna_Barn.setObjectName("groupBox_Egna_Barn")
        self.groupBox_Egna_Barn.setTitle("Barn")


        self.pushButton_Upp = QtGui.QPushButton(self.groupBox_Egna_Barn)
        self.pushButton_Upp.setEnabled(False)
        self.pushButton_Upp.setObjectName("pushButton_Upp")
        self.pushButton_Upp.setText("upp")
        self.pushButton_Upp.setDefault(True)

        self.pushButton_Ned = QtGui.QPushButton(self.groupBox_Egna_Barn)
        self.pushButton_Ned.setEnabled(False)
        self.pushButton_Ned.setObjectName("pushButton_Ned")
        self.pushButton_Ned.setText("ned")



        self.tableWidget_Barn = sijTableWidget(self.groupBox_Egna_Barn)
        self.tableWidget_Barn.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_Barn.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)
        self.tableWidget_Barn.setDragEnabled(False)
        self.tableWidget_Barn.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_Barn.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_Barn.setTextElideMode(QtCore.Qt.ElideMiddle)
        self.tableWidget_Barn.setObjectName("tableWidget_Barn")

        self.tableWidget_Barn.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_Barn.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

        self.tableWidget_Barn.verticalHeader().setVisible(False)

# preparera tabell för att visa barn i (så de kan sorteras)
# Måste göras före anropet till self.fyllGui
# --- Tömmer och nollställer eventuell gammal tabell ---
        self.tableWidget_Barn.clear()
        self.tableWidget_Barn.setColumnCount(3)
        self.tableWidget_Barn.setRowCount(0)

# --- Preparerar tabell ---
        headerItem0 = QtGui.QTableWidgetItem( "ID")
        headerItem1 = QtGui.QTableWidgetItem( "född år")
        headerItem2 = QtGui.QTableWidgetItem( "namn")

        self.tableWidget_Barn.setHorizontalHeaderItem( 0, headerItem0)
        self.tableWidget_Barn.setHorizontalHeaderItem( 1, headerItem1)
        self.tableWidget_Barn.setHorizontalHeaderItem( 2, headerItem2)


# Rutan 'groupBox_Bonusrelationer'
        self.groupBox_Bonusrelationer = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Bonusrelationer.setObjectName("groupBox_Bonusrelationer")
        self.groupBox_Bonusrelationer.setTitle("Bonusrelationer")

        self.textEdit_Bonusrelation_ID = sijTextEdit(self.groupBox_Bonusrelationer)
        self.textEdit_Bonusrelation_ID.setEnabled(False)
        self.textEdit_Bonusrelation_ID.setObjectName("textEdit_Bonusrelation_ID")

        self.textEdit_Bonusrelation_ID_2 = sijTextEdit(self.groupBox_Bonusrelationer)
        self.textEdit_Bonusrelation_ID_2.setEnabled(False)
        self.textEdit_Bonusrelation_ID_2.setObjectName("textEdit_Bonusrelation_ID_2")

        self.textEdit_Bonusrelation_ID.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_Bonusrelation_ID.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)


        self.textEdit_Bonusrelation_ID_2.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)     #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.textEdit_Bonusrelation_ID_2.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)



# Rutan 'groupBox_Länkar'
        self.groupBox_länkar = QtGui.QGroupBox(self.inneryta)
        self.groupBox_länkar.setObjectName("groupBox_länkar")
        self.groupBox_länkar.setTitle("Länkar")

        self.tableWidget_länkar = sijTableWidget(self.groupBox_länkar)
        self.tableWidget_länkar.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.tableWidget_länkar.setContextMenuPolicy(QtCore.Qt.DefaultContextMenu)
        self.tableWidget_länkar.setDragEnabled(False)
        self.tableWidget_länkar.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.tableWidget_länkar.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.tableWidget_länkar.setTextElideMode(QtCore.Qt.ElideMiddle)
        self.tableWidget_länkar.setObjectName("tableWidget_länkar")

        self.tableWidget_länkar.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)       #  Qt.ScrollBarAlwaysOn,  Qt.ScrollBarAlwaysOff,  Qt.ScrollBarAsNeeded
        self.tableWidget_länkar.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)

        self.tableWidget_länkar.verticalHeader().setVisible(False)

        self.tableWidget_länkar.clear()
        self.tableWidget_länkar.setColumnCount(3)
        self.tableWidget_länkar.setRowCount(0)

# --- Preparerar tabell ---
# OBS kolumn nr 0 är dold (bredd=0) och utnyttjas av programkoden
#        headerItem0 = QtGui.QTableWidgetItem( "")
        headerItem1 = QtGui.QTableWidgetItem( "Skapa/Öppna ... ")
        headerItem2 = QtGui.QTableWidgetItem( "Filnamn")

#        self.tableWidget_länkar.setHorizontalHeaderItem( 0, headerItem0)
        self.tableWidget_länkar.setHorizontalHeaderItem( 1, headerItem1)
        self.tableWidget_länkar.setHorizontalHeaderItem( 2, headerItem2)



# Rutan 'groupBox_Anteckningar'
        self.groupBox_anteckning = QtGui.QGroupBox(self.inneryta)
        self.groupBox_anteckning.setObjectName("groupBox_anteckning")
        self.groupBox_anteckning.setTitle("Anteckningar")

        self.textEdit_Anteckningar = sijTextEdit(self.groupBox_anteckning)
        self.textEdit_Anteckningar.setObjectName("textEdit_Anteckningar")
        self.textEdit_Anteckningar.setTabChangesFocus(True)


# Rutan 'Händelse_inledning
        self.Händelse_inledning = Händelseruta(self.inneryta, self.fontsize)
        self.Händelse_inledning.groupBox_Händelse.setTitle("Inledning")



# Rutan 'Händelse_upplösning
        self.Händelse_upplösning = Händelseruta(self.inneryta, self.fontsize)
        self.Händelse_upplösning.groupBox_Händelse.setTitle("Upplösning")



# Rutan 'groupBox_Fler_Källor
        self.groupBox_Fler_Källor = QtGui.QGroupBox(self.inneryta)
        self.groupBox_Fler_Källor.setObjectName("groupBox_Fler_Källor")
        self.groupBox_Fler_Källor.setTitle("Fler källor")

        self.textEdit_Fler_Källor = sijTextEdit(self.groupBox_Fler_Källor)
        self.textEdit_Fler_Källor.setObjectName("textEdit_Fler_Källor")
        self.textEdit_Fler_Källor.setTabChangesFocus(True)


# Längst ner till höger
        self.label_SenastSparat = QtGui.QLabel(self.inneryta)
        self.label_SenastSparat.setObjectName(" self.label_SenastSparat")
        self.label_SenastSparat.setText("Senast sparat/ändrat  ")
        self.label_SenastSparat.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignLeft))

        self.lineEdit_SenastSparat = sijLineEdit(self.inneryta)
        self.lineEdit_SenastSparat.setObjectName("lineEdit_SenastSparat")
        self.lineEdit_SenastSparat.setEnabled(False)
        self.lineEdit_SenastSparat.setAlignment(Qt.Alignment(Qt.AlignVCenter | Qt.AlignHCenter))
#*****************************************************************************************

        brush = QtGui.QBrush()
        brush.setStyle(QtCore.Qt.SolidPattern)

#        palette_inneryta
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_inneryta.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_inneryta.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window,brush)
        self.palette_inneryta.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window,brush)
        brush = QtGui.QBrush(QtGui.QColor(0,0,0))       # svart
        self.palette_inneryta.setBrush( QtGui.QPalette.Active,   QtGui.QPalette.WindowText, brush )
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
        self.palette_inneryta.setBrush( QtGui.QPalette.Inactive, QtGui.QPalette.WindowText, brush )
        self.palette_inneryta.setBrush( QtGui.QPalette.Disabled, QtGui.QPalette.WindowText, brush )
        self.inneryta.setPalette(self.palette_inneryta)

#        palette_ytteryta_normal
        brush = QtGui.QBrush(QtGui.QColor(240,240,240)) # ljus grå
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(228,228,228)) # något mörkare grå grå
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_ytteryta_normal.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)

#        palette_ytteryta_spara
        brush = QtGui.QBrush(QtGui.QColor(255,200,200))  # ljus röd
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Window, brush)
        brush = QtGui.QBrush(QtGui.QColor(240,0,0))      # stark röd
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.Window, brush)
        self.palette_ytteryta_spara.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.Window, brush)
        self.ytteryta.setPalette(self.palette_ytteryta_normal)

 #       self.palette_sparaknapp_normal
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Active, QtGui.QPalette.ButtonText, brush)
        brush = QtGui.QBrush(QtGui.QColor(80,80,80))    # grå
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.ButtonText, brush)
        self.palette_sparaknapp_normal.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.ButtonText, brush)

#        self.palette_sparaknapp_spara
        brush = QtGui.QBrush(QtGui.QColor(255,0,0))  # stark röd
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Active, QtGui.QPalette.ButtonText, brush)
        brush = QtGui.QBrush(QtGui.QColor(240,0,0))  # stark röd
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Inactive, QtGui.QPalette.ButtonText, brush)
        self.palette_sparaknapp_spara.setBrush(QtGui.QPalette.Disabled, QtGui.QPalette.ButtonText, brush)
        self.pushButton_Spara.setPalette(self.palette_sparaknapp_normal)

#*****************************************************************************************

# detta ska vara med på något sätt

        Parblad.setTabOrder(self.textEdit_Anteckningar,self.lineEdit_Person2_namn)
        Parblad.setTabOrder(self.lineEdit_Person2_namn,self.pushButton_Upp)
        Parblad.setTabOrder(self.pushButton_Upp,self.lineEdit_Person1_namn)
        Parblad.setTabOrder(self.lineEdit_Person1_namn,self.tableWidget_Barn)
        Parblad.setTabOrder(self.tableWidget_Barn,self.pushButton_Ned)
        Parblad.setTabOrder(self.pushButton_Ned,self.lineEdit_Person1_ID)
        Parblad.setTabOrder(self.lineEdit_Person1_ID,self.lineEdit_Person2_ID)
        Parblad.setTabOrder(self.lineEdit_Person2_ID,self.lineEdit_Par_ID)
        Parblad.setTabOrder(self.lineEdit_Par_ID,self.lineEdit_Databas)
        Parblad.setTabOrder(self.lineEdit_Databas,self.lineEdit_Parnummer)
        Parblad.setTabOrder(self.lineEdit_Parnummer,self.pushButton_RitaOm)
        Parblad.setTabOrder(self.pushButton_RitaOm,self.pushButton_Spara)

###################################################################################################




###################################################################################################
    def enableUi(self):
        self.lineEdit_Parnummer.setEnabled(True)
        self.pushButton_RitaOm.setEnabled(True)

        self.pushButton_Upp.setEnabled(True)
        self.pushButton_Ned.setEnabled(True)

        self.textEdit_Bonusrelation_ID.setEnabled(True)
        self.textEdit_Bonusrelation_ID_2.setEnabled(False) # endast för utmatning från programmet
###################################################################################################




###################################################################################################
    def fontsizeup(self):
        self.fontsize = self.fontsize + 1
        self.fontsizeset()

    def fontsizedown(self):
        self.fontsize = self.fontsize - 1
        self.fontsizeset()

    def fontsizeset(self):
        if self.fontsize < 6:
            self.fontsize = 6
        if self.fontsize > 18:
            self.fontsize = 18

        font = QFont()
        font.setPointSize(self.fontsize)
        font.setWeight(50)
        font.setBold(False)

        fontBold =  QFont()
        font.setPointSize(self.fontsize)
        fontBold.setWeight(75)
        fontBold.setBold(True)

        self.scrollyta.setFont(font)

# frame_Top
        self.frame_top.setFont(fontBold)
        self.label_Databas.setFont(font)
        self.lineEdit_Databas.setFont(font)
        self.pushButton_Databas.setFont(font)
        self.label_Parnummer.setFont(font)
        self.lineEdit_Parnummer.setFont(font)
        self.pushButton_RitaOm.setFont(font)
        self.pushButton_Spara.setFont(font)

# groupBox_Par
        self.groupBox_Par.setFont(fontBold)
        self.label_Par_ID.setFont(font)
        self.lineEdit_Par_ID.setFont(font)
        self.label_Person1_ID.setFont(font)
        self.lineEdit_Person1_ID.setFont(font)
        self.label_Person1_namn.setFont(font)
        self.lineEdit_Person1_namn.setFont(font)
        self.label_Person2_ID.setFont(font)
        self.label_Person2_namn.setFont(font)
        self.lineEdit_Person2_namn.setFont(font)


# groupBox_Barn
        self.groupBox_Egna_Barn.setFont(fontBold)
        self.pushButton_Upp.setFont(font)
        self.pushButton_Ned.setFont(font)
        self.tableWidget_Barn.setFont(font)



# 'groupBox_Bonusrelationer
        self.groupBox_Bonusrelationer.setFont(fontBold)
        self.textEdit_Bonusrelation_ID.setFont(font)
        self.textEdit_Bonusrelation_ID_2.setFont(font)


# groupBox_Länkar
        self.groupBox_länkar.setFont(fontBold)
        self.tableWidget_länkar.setFont(font)


# groupBox_Anteckningar
        self.groupBox_anteckning.setFont(fontBold)
        self.textEdit_Anteckningar.setFont(font)


# Längst ner till höger
        self.label_SenastSparat.setFont(font)
        self.lineEdit_SenastSparat.setFont(font)


# Rutan 'Händelse_inledning
# Rutan 'Händelse_upplösning
        self.Händelse_inledning.sättHändelsestorlek(self.fontsize)
        self.Händelse_upplösning.sättHändelsestorlek(self.fontsize)

        for each in [ self.Händelse_upplösning, self.Händelse_inledning ]:

            each.groupBox_Händelse.setFont(fontBold)

            each.groupBox_typ.setFont(QFont("Normal"))
            each.groupBox_datum.setFont(fontBold)
            each.groupBox_plats.setFont(fontBold)
            each.groupBox_källa.setFont(fontBold)

            each.lineEdit_typ.setFont(font)
            each.label_dag.setFont(font)
            each.lineEdit_dag.setFont(font)
            each.label_månad.setFont(font)
            each.lineEdit_månad.setFont(font)
            each.label_år.setFont(font)
            each.lineEdit_år.setFont(font)
            each.label_gata.setFont(font)
            each.lineEdit_gata.setFont(font)
            each.label_by.setFont(font)
            each.lineEdit_by.setFont(font)
            each.label_kvarter.setFont(font)
            each.lineEdit_kvarter.setFont(font)
            each.label_socken.setFont(font)
            each.lineEdit_socken.setFont(font)
            each.label_församling.setFont(font)
            each.lineEdit_församling.setFont(font)
            each.label_disbytförsamling.setFont(font)
            each.lineEdit_disbytförsamling.setFont(font)
            each.label_stad.setFont(font)
            each.lineEdit_stad.setFont(font)
            each.label_härad.setFont(font)
            each.lineEdit_härad.setFont(font)
            each.label_län.setFont(font)
            each.lineEdit_län.setFont(font)
            each.label_utrikesplats.setFont(font)
            each.lineEdit_utrikesplats.setFont(font)
            each.textEdit_källa.setFont(font)



# Rutan 'groupBox_Fler_Källor
        self.groupBox_Fler_Källor.setFont(fontBold)
        self.textEdit_Fler_Källor.setFont(font)



        self.ritaom() # Hämta data först och sätt storlekar sedan så får vi rätt antal rader i tabeller

        return
###################################################################################################




###################################################################################################
    def sijlayout(self):

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.scrollyta.verticalScrollBar().setFixedWidth(fh)

        self.tableWidget_Barn.verticalScrollBar().setFixedWidth(fh)
        self.tableWidget_Barn.horizontalScrollBar().setFixedHeight(fh)

        self.textEdit_Bonusrelation_ID.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_Bonusrelation_ID.horizontalScrollBar().setFixedHeight(fh)

        self.textEdit_Bonusrelation_ID_2.verticalScrollBar().setFixedWidth(fh)
        self.textEdit_Bonusrelation_ID_2.horizontalScrollBar().setFixedHeight(fh)

        self.tableWidget_länkar.verticalScrollBar().setFixedWidth(fh)
        self.tableWidget_länkar.horizontalScrollBar().setFixedHeight(fh)


# Layout av rutan frame_top högst uppe till vänster

        radleft = 3
        radhojd = fh
        rad0top = 2
        rad1top = 3+fh

        b1 = max([metrics.width(self.label_Databas.text()), metrics.width(self.label_Parnummer.text())])
        sparaBredd = fs + metrics.width(self.pushButton_RitaOm.text())

#        self.label_Databas.setGeometry      ( QtCore.QRect (      radleft, rad0top,                                  b1, radhojd ))
#        self.lineEdit_Databas.setGeometry   ( QtCore.QRect ( radleft+b1+2, rad0top,                             40 * fs, radhojd ))
#        self.label_Parnummer.setGeometry    ( QtCore.QRect (      radleft, rad1top,                                  b1, radhojd ))
#        self.lineEdit_Parnummer.setGeometry ( QtCore.QRect ( radleft+b1+2, rad1top, 2*fs + metrics.width("par00000000"), radhojd ))

#        self.pushButton_RitaOm.setGeometry  ( QtCore.QRect (       3*fs+self.lineEdit_Parnummer.geometry().right(), rad1top, fs + metrics.width(self.pushButton_RitaOm.text()), 1.2 * radhojd ))
#        self.pushButton_Spara.setGeometry   ( QtCore.QRect ( self.lineEdit_Databas.geometry().right() - sparaBredd, rad1top,                                        sparaBredd, 1.2 * radhojd ))

        self.label_Databas.setGeometry         (                                         2,                                          2,                               b1, fh )
        self.lineEdit_Databas.setGeometry      ( 1 + self.label_Databas.geometry().right(),                                          2,                          40 * fs, fh )
        self.label_Parnummer.setGeometry    (                                         2, 1 + self.label_Databas.geometry().bottom(),                               b1, fh )
        self.lineEdit_Parnummer.setGeometry ( 1 + self.label_Databas.geometry().right(),   self.label_Parnummer.geometry().top(), fs + metrics.width("par00000000"), fh )

        pushButtonBredd1 = fs + max ( metrics.width(self.pushButton_RitaOm.text()), metrics.width(self.pushButton_Spara.text()) )
        pushButtonBredd2 = fs + metrics.width(self.pushButton_Databas.text())

        self.pushButton_RitaOm.setGeometry     (          3*fs+self.lineEdit_Parnummer.geometry().right(), self.label_Parnummer.geometry().top(), pushButtonBredd1,  fh )
        self.pushButton_Spara.setGeometry      (             3*fs +self.pushButton_RitaOm.geometry().right(), self.label_Parnummer.geometry().top(), pushButtonBredd1,  fh )
        self.pushButton_Databas.setGeometry    ( self.lineEdit_Databas.geometry().right() - pushButtonBredd2, self.label_Parnummer.geometry().top(), pushButtonBredd2,  fh )

# --------------------------------

# Layout av rutan 'groupBox_Par'

        b1 = fs + max ([ metrics.width(self.label_Par_ID.text()), metrics.width(self.label_Person1_namn.text()), metrics.width(self.label_Person2_namn.text())  ])
        b2 = fs + max ([ metrics.width(self.label_Person1_ID.text()), metrics.width(self.label_Person2_ID.text())  ])


        self.label_Par_ID.setGeometry          ( QtCore.QRect (                                      radleft,                                          fh,                                b1, fh ))
        self.lineEdit_Par_ID.setGeometry       ( QtCore.QRect (     3 + self.label_Par_ID.geometry().right(),                                          fh, fs + metrics.width("par00000000"), fh ))

        self.label_Person1_ID.setGeometry      ( QtCore.QRect (                                      radleft,       self.label_Par_ID.geometry().bottom(),                                b2, fh ))
        self.lineEdit_Person1_ID.setGeometry   ( QtCore.QRect ( 3 + self.label_Person1_ID.geometry().right(),       self.label_Par_ID.geometry().bottom(),    fs + metrics.width("00000000"), fh ))

        self.label_Person1_namn.setGeometry    ( QtCore.QRect (                                      radleft,   self.label_Person1_ID.geometry().bottom(),                                b1, fh ))
        self.lineEdit_Person1_namn.setGeometry ( QtCore.QRect (     3 + self.label_Par_ID.geometry().right(),   self.label_Person1_ID.geometry().bottom(),                           30 * fs, fh ))

        self.label_Person2_ID.setGeometry      ( QtCore.QRect (                                      radleft, self.label_Person1_namn.geometry().bottom(),                                b2, fh ))
        self.lineEdit_Person2_ID.setGeometry   ( QtCore.QRect ( 3 + self.label_Person2_ID.geometry().right(), self.label_Person1_namn.geometry().bottom(),    fs + metrics.width("00000000"), fh ))

        self.label_Person2_namn.setGeometry    ( QtCore.QRect (                                      radleft,   self.label_Person2_ID.geometry().bottom(),                                b1, fh ))
        self.lineEdit_Person2_namn.setGeometry ( QtCore.QRect (     3 + self.label_Par_ID.geometry().right(),   self.label_Person2_ID.geometry().bottom(),                           30 * fs, fh ))



# Layout av rutan 'groupBox_Egna_Barn'
        b1 = fs + max ([ metrics.width(self.pushButton_Upp.text()),metrics.width(self.pushButton_Ned.text()) ])
        self.pushButton_Upp.setGeometry ( radleft,                                     2 * fh , b1,  fh )
        self.pushButton_Ned.setGeometry ( radleft, 2 + self.pushButton_Upp.geometry().bottom(), b1,  fh )

        if self.tableWidget_Barn.rowCount() > 1:
            self.pushButton_Upp.setVisible(True)
            self.pushButton_Ned.setVisible(True)
        else:
            self.pushButton_Upp.setVisible(False)
            self.pushButton_Ned.setVisible(False)

# radhöjd för alla rader
        for i in range (0, self.tableWidget_Barn.rowCount()):
            self.tableWidget_Barn.setRowHeight(i, fh)


# kolumnbredder
        self.tableWidget_Barn.setColumnWidth(0,  8 * fs)
        self.tableWidget_Barn.setColumnWidth(1,  6 * fs)
        self.tableWidget_Barn.setColumnWidth(2, 26 * fs)

        s1=4
        i1=0
        while i1 <  self.tableWidget_Barn.columnCount():
            s1 = s1 + self.tableWidget_Barn.columnWidth(i1)
            i1=i1+1

        tableWidget_Barn_Rect = self.tableWidget_Barn.geometry()
        tableWidget_Barn_Rect.setLeft( 3 + self.pushButton_Upp.geometry().right(),)
        tableWidget_Barn_Rect.setTop(fh)
        tableWidget_Barn_Rect.setWidth(s1)
        tableWidget_Barn_Rect.setHeight( self.tableWidget_Barn.rowViewportPosition( self.tableWidget_Barn.rowCount()-1 ) + 2.5*fh + 6)
        self.tableWidget_Barn.setGeometry(tableWidget_Barn_Rect )



# Layout av rutan 'groupBox_Bonusrelationer'
        b1 =  2*fs + metrics.width("par00000000") + self.textEdit_Bonusrelation_ID.verticalScrollBar().width()
        self.textEdit_Bonusrelation_ID.setGeometry ( radleft, fh, b1 , 4*fh )
        self.textEdit_Bonusrelation_ID_2.setGeometry (3+self.textEdit_Bonusrelation_ID.geometry().right(), fh, 31*fs , 4*fh )


# Layout av rutan 'groupBox_Länkar'


# radhöjd för alla rader
        for i in range (0, self.tableWidget_länkar.rowCount()):
           self.tableWidget_länkar.setRowHeight(i, fh)


# kolumnbredder
        self.tableWidget_länkar.setColumnWidth(0,  0)
        self.tableWidget_länkar.setColumnWidth(1, 20 * fs)
        self.tableWidget_länkar.setColumnWidth(2, 23 * fs)

        s1=4
        i1=0
        while i1 <  self.tableWidget_länkar.columnCount():
            s1 = s1 + self.tableWidget_länkar.columnWidth(i1)
            i1=i1+1

        tableWidget_länkar_Rect = self.tableWidget_länkar.geometry()
        tableWidget_länkar_Rect.setLeft( radleft)
        tableWidget_länkar_Rect.setTop(fh)
        tableWidget_länkar_Rect.setWidth(s1)
        tableWidget_länkar_Rect.setHeight( self.tableWidget_länkar.rowViewportPosition( self.tableWidget_länkar.rowCount()-1 ) + 2.5*fh + 6)
        self.tableWidget_länkar.setGeometry(tableWidget_länkar_Rect )


# Layout av rutan 'groupBox_Anteckningar'
        self.textEdit_Anteckningar.setGeometry ( radleft, fh, 43*fs , 6*fh )


# Layout av rutan 'groupBox_Inledning
#        self.textEdit_Inledning_Källor.setFixedHeight(50)
#        self.textEdit_Inledning_Källor.setTabChangesFocus(True)



# Layout av rutan 'groupBox_Upplösning
#        self.textEdit_Upplosning_Källor.setFixedHeight(50)
#        self.textEdit_Upplosning_Källor.setTabChangesFocus(True)



# Layout av rutan 'groupBox_Fler_Källor
        self.textEdit_Fler_Källor.setGeometry( radleft, fh, 43*fs , 6*fh )

        return
###################################################################################################

####################################################
##                                                ##
##   setGeometry ( int x, int y, int w, int h )   ##
##                                                ##
####################################################

#################################    ----------> X
##                             ##    |
##   resize ( int w, int h )   ##    |
##                             ##    |
#################################    V  y

###################################################################################################
    def windowlayout(self):  # Anpassning av fönstret till tabellen

# windowlayout anropas endast som en fortsättning av sijlayout ovan
# inte någon annanstans ifrån..

        from johangemensamt import allmänt as allm
        font = QFont()
        font.setPointSize(self.fontsize)
        fs = allm.Horisontalfaktor * font.pointSize()
        metrics = QFontMetrics(font)
        fh = allm.Vertikalfaktor * metrics.height()

        self.frame_top.setGeometry                ( QtCore.QRect ( 2,                                                          2,      3 + self.lineEdit_Databas.geometry().right(),         4 + self.pushButton_RitaOm.geometry().bottom() ))
        self.groupBox_Par.setGeometry             ( QtCore.QRect ( 2,                     2 + self.frame_top.geometry().bottom(), 3 + self.lineEdit_Person2_namn.geometry().right(),     3 + self.lineEdit_Person2_namn.geometry().bottom() ))
        self.groupBox_Egna_Barn.setGeometry       ( QtCore.QRect ( 2,             2 + self.groupBox_Par.frameGeometry().bottom(),                 self.frame_top.geometry().width(),          3 + self.tableWidget_Barn.geometry().bottom() ))
        self.groupBox_Bonusrelationer.setGeometry ( QtCore.QRect ( 2,       2 + self.groupBox_Egna_Barn.frameGeometry().bottom(),                 self.frame_top.geometry().width(), 3 + self.textEdit_Bonusrelation_ID.geometry().bottom() ))
        self.groupBox_länkar.setGeometry          ( QtCore.QRect ( 2, 2 + self.groupBox_Bonusrelationer.frameGeometry().bottom(),                 self.frame_top.geometry().width(),        3 + self.tableWidget_länkar.geometry().bottom() ))
        self.groupBox_anteckning.setGeometry      ( QtCore.QRect ( 2,          2 + self.groupBox_länkar.frameGeometry().bottom(),                 self.frame_top.geometry().width(),     3 + self.textEdit_Anteckningar.geometry().bottom() ))
        self.groupBox_Fler_Källor.setGeometry     ( QtCore.QRect ( 2,      2 + self.groupBox_anteckning.frameGeometry().bottom(),                 self.frame_top.geometry().width(),      3 + self.textEdit_Fler_Källor.geometry().bottom() ))

        self.Händelse_inledning.groupBox_Händelse.setGeometry  ( QtCore.QRect (                            5 + self.frame_top.geometry().right(),                                                                      2,  self.Händelse_inledning.groupBox_Händelse.geometry().width(),  self.Händelse_inledning.groupBox_Händelse.geometry().height() ))
        self.Händelse_upplösning.groupBox_Händelse.setGeometry ( QtCore.QRect ( self.Händelse_inledning.groupBox_Händelse.frameGeometry().left(), 2 + self.Händelse_inledning.groupBox_Händelse.frameGeometry().bottom(), self.Händelse_upplösning.groupBox_Händelse.geometry().width(), self.Händelse_upplösning.groupBox_Händelse.geometry().height() ))



# Längst ner till höger


        self.lineEdit_SenastSparat.resize(17*fs, fh)
        self.label_SenastSparat.resize   (3 + metrics.width(self.label_SenastSparat.text()), fh)




# placering inom inneryta

        nettohojd  = 2 + max ([ self.groupBox_Fler_Källor.frameGeometry().bottom() ,  self.Händelse_upplösning.groupBox_Händelse.frameGeometry().bottom() + 2 + fh  ]) # innehåller höjdutrymme=fh för SenastSparat
        nettobredd = 2 + self.Händelse_upplösning.groupBox_Händelse.frameGeometry().right()


        self.lineEdit_SenastSparat.move (nettobredd - 2 - self.lineEdit_SenastSparat.geometry().width(),  nettohojd - 2 - fh)
        self.label_SenastSparat.move    ( self.lineEdit_SenastSparat.geometry().left() - self.label_SenastSparat.geometry().width(), self.lineEdit_SenastSparat.geometry().top() )


        self.inneryta.setGeometry( QtCore.QRect ( 5, 5, 2 + nettobredd, 2 + nettohojd ))
        self.scrollyta.setGeometry =  self.inneryta.geometry()
        self.ytteryta.setGeometry( QtCore.QRect ( 0, 0, 7 + nettobredd, 7 + nettohojd ))
        self.resize(QtCore.QSize(12 + nettobredd, 12 + nettohojd ))

        self.textEdit_Anteckningar.setFocus()

###################################################################################################




###################################################################################################
# kopplingar till knappar i grafiska gränsytan
    def ui_connections(self):

        for each in [ self.Händelse_upplösning, self.Händelse_inledning ]:

            self.connect(each.lineEdit_typ,                   SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_dag,                   SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_månad,                 SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_år,                    SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_gata,                  SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_by,                    SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_kvarter,               SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_socken,                SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_församling,            SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_stad,                  SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_härad,                 SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_län,                   SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("textEdited(QString)"), self.dirtybit_set)
            self.connect(each.textEdit_källa,                 SIGNAL("textChanged()"),       self.dirtybit_set)

            self.connect(each.lineEdit_typ,                   SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_dag,                   SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_månad,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_år,                    SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_gata,                  SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_by,                    SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_kvarter,               SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_socken,                SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_församling,            SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_stad,                  SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_härad,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_län,                   SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("CtrlPlusPressed"),  self.fontsizeup)
            self.connect(each.textEdit_källa,                 SIGNAL("CtrlPlusPressed"),  self.fontsizeup)

            self.connect(each.lineEdit_typ,                   SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_dag,                   SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_månad,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_år,                    SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_gata,                  SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_by,                    SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_kvarter,               SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_socken,                SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_församling,            SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_stad,                  SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_härad,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_län,                   SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("CtrlMinusPressed"), self.fontsizedown)
            self.connect(each.textEdit_källa,                 SIGNAL("CtrlMinusPressed"), self.fontsizedown)

            self.connect(each.lineEdit_typ,                   SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_dag,                   SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_månad,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_år,                    SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_gata,                  SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_by,                    SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_kvarter,               SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_socken,                SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_församling,            SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_disbytförsamling,      SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_stad,                  SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_härad,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_län,                   SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.lineEdit_utrikesplats,          SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )
            self.connect(each.textEdit_källa,                 SIGNAL("Ctrl_S_Pressed"),   self.sparaknapp   )

        self.connect(self.lineEdit_Databas,               SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.lineEdit_Databas,               SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect ( self.lineEdit_Databas,             SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.lineEdit_Parnummer,             SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.lineEdit_Parnummer,             SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.lineEdit_Parnummer,             SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.tableWidget_Barn,               SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.tableWidget_Barn,               SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.tableWidget_Barn,               SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.textEdit_Bonusrelation_ID,      SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.textEdit_Bonusrelation_ID,      SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.textEdit_Bonusrelation_ID,      SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.tableWidget_länkar,             SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.tableWidget_länkar,             SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.tableWidget_länkar,             SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.textEdit_Anteckningar,          SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.textEdit_Anteckningar,          SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.textEdit_Anteckningar,          SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )

        self.connect(self.textEdit_Fler_Källor,           SIGNAL("CtrlPlusPressed"),      self.fontsizeup   )
        self.connect(self.textEdit_Fler_Källor,           SIGNAL("CtrlMinusPressed"),     self.fontsizedown )
        self.connect(self.textEdit_Fler_Källor,           SIGNAL("Ctrl_S_Pressed"),       self.sparaknapp   )


        self.connect(self.textEdit_Fler_Källor,   SIGNAL("textChanged()"),        self.dirtybit_set)
        self.connect(self.textEdit_Anteckningar,  SIGNAL("textChanged()"),        self.dirtybit_set)

        self.connect(self.pushButton_Upp,         SIGNAL("clicked()"),            self.uppknapp)
        self.connect(self.pushButton_Ned,         SIGNAL("clicked()"),            self.nedknapp)

        self.connect(self.pushButton_Spara,       SIGNAL("clicked()"),            self.sparaknapp)
        self.connect(self.pushButton_RitaOm,      SIGNAL("clicked()"),            self.ritaomknapp)
        self.connect(self.lineEdit_Parnummer,     SIGNAL("returnPressed()"),      self.ritaomknapp)

        self.connect(self.tableWidget_länkar,     SIGNAL("cellClicked(int,int)"), self.lankarknapp)

###################################################################################################
